<?php

class DeveloperTaskModel extends CI_Model {

	public function __construct() {

		// Call the Model constructor
		parent::__construct();
	}

	public function getcriticalUpadte($userid){
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND  critical_update = 1 AND status IN (10,20) group by task_no");
		return $qry->row();
	}


	public function getnewpendingCount($userid){
		$qry = $this->db->query("SELECT count(pending) as pending FROM(SELECT task_no AS pending FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND `type` != 'bug' AND `status` = '10' group by task_no) AS TASK");
		if ($qry->num_rows() > 0) {
			return $qry->row()->pending;
		}
	}
	public function getpendingbugsCount($userid){
		$qry = $this->db->query("SELECT count(bugs) as bugs FROM(SELECT task_no AS bugs FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND `status` = '10' AND `type` = 'bug' ) AS TASK");
		if ($qry->num_rows() > 0) {
			return $qry->row()->bugs;
		}
	}
	public function getinprogressCount($userid){
		$qry = $this->db->query("SELECT count(progress) as progress FROM(SELECT task_no AS progress FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND `status` = '20' AND `type` != 'bug' group by task_no) AS TASK");
		if ($qry->num_rows() > 0) {
			return $qry->row()->progress;
		}
	}
	public function getinprogresbugCount($userid){
		$qry = $this->db->query("SELECT count(progressbug) as progressbug FROM(SELECT task_no AS progressbug FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND `status` = '20' AND `type` = 'bug' ) AS TASK");
		if ($qry->num_rows() > 0) {
			return $qry->row()->progressbug;
		}
	}
	public function gettestnewCount($userid){
		$qry = $this->db->query("SELECT count(testnew) as testnew FROM(SELECT task_no AS testnew FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND `status` = '30' AND `type` != 'bug'   group by task_no) AS TASK");
		if ($qry->num_rows() > 0) {
			return $qry->row()->testnew;
		}
	}
	public function gettesttestbugCount($userid){
		$qry = $this->db->query("SELECT count(testbug) as testbug FROM(SELECT task_no AS testbug FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND `status` = '30' AND  `type` = 'bug'  ) AS TASK");
		if ($qry->num_rows() > 0) {
			return $qry->row()->testbug;
		}
	}
	public function getsendbackCount($userid){
		$qry = $this->db->query("SELECT count(sendback) as sendback FROM(SELECT task_no AS sendback FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND `status` IN(21,51) ) AS TASK");
		if ($qry->num_rows() > 0) {
			return $qry->row()->sendback;
		}
	}


	//public function getbugtestpendingTaskList($userid)
	//{
	//	$qry = $this->db->query("SELECT count(testbug) as testbug FROM(SELECT task_no AS testbug FROM `task_allocation` WHERE `assign_id` = '" . $userid . "' AND `status` = '7' AND  `type` = 'bug'  ) AS TASK");
	//	if ($qry->num_rows() > 0) {
	//		return $qry->row()->testbug;
	//	}
	//}

	public function getPendingTaskLIst($status, $userid){
		$this->db->select("*");
		$this->db->from('task_allocation');
		$this->db->where('status', $status);
		$this->db->where('assign_id', $userid);
		$this->db->where('type != ', 'bug');
		$this->db->group_by('task_no');
		$result = $this->db->get();
		return $result->result_array();
	}

	public function getdevTaskdetail($taskno,$userid,$taskid){
		if (!empty($taskno)) {
			$condition = "AND `task_no` = '" . $taskno . "'";
		} else {
			$condition = "AND `task_id` = '" . $taskid . "'";
		}

		$qry = $this->db->query("SELECT `task_no`,`client_id`,`project_name`,`type`,`job_id`,`product` FROM `task_allocation` WHERE `assign_id` = '".$userid."'  $condition AND `status` = '10'  ");
		return $qry->row();
	}

	public function getdevTaskSummary($taskno, $userid,$taskid){
		if(!empty($taskno)){
			$condition = "AND `task_no` = '".$taskno."'";
		}
		else{
			$condition = "AND `task_id` = '" .$taskid."'";
		}
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '" . $userid . "' $condition AND `status` = '10'  ");
		return $qry->result_array();
	}

	public function getdeveloperTaskLIst($status, $userid, $type){
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '" .$userid."' AND `type` = 'bug' AND `status` = '10'  ");
		return $qry->result_array();
	}

	public function getClientdata()
	{
		$query = $this->db->query("SELECT `client_name`,`client_id` FROM `new_client_master`  order by client_name");
		return $query->result_array();

	}

	public function UpdateTaskStatusdata($taskno, $userid){
		$update_date = date("Y-m-d H:i:s");
		$query = $this->db->query("UPDATE `task_allocation` SET `status` = 20 WHERE `assign_id` = '".$userid."' AND `task_no` = '".$taskno."'");
		if ($query) {
			$qry = $this->db->query("SELECT task_id FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND `task_no` = '".$taskno."'" );
			foreach ($qry->result_array() as $row) {
				$this->db->query("INSERT INTO `task_log`(
				`task_id`,
				`task_no`,
				`task_date`,
				`task_status`,
				`user_id`)
				VALUES (
				'".$row['task_id']."',
				'". $taskno."',
				'".$update_date."',
				'dev_pick',
				'". $userid."')");
			}

			return true;
		} else {
			return false;
		}
	}

	public function UpdateCritTaskStatusdata($taskno, $userid){
		$update_date = date("Y-m-d H:i:s");
		$qry = $this->db->query("SELECT `task_status` FROM `task_log` WHERE `task_status` = 'dev_pick'AND `task_no` = '".$taskno."'");
		if($qry->num_rows() > 0){
			return true;
		}
		else{	
		$query = $this->db->query("UPDATE `task_allocation` SET `status` = 20 WHERE `assign_id` = '".$userid."' AND `task_no` = '".$taskno."'");
			if ($query) {
				$qry = $this->db->query("SELECT task_id FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND `task_no` = '".$taskno."'" );
				foreach ($qry->result_array() as $row) {
					$this->db->query("INSERT INTO `task_log`(
					`task_id`,
					`task_no`,
					`task_date`,
					`task_status`,
					`user_id`)
					VALUES (
					'".$row['task_id']."',
					'". $taskno."',
					'".$update_date."',
					'dev_pick',
					'". $userid."')");
				}
			return true;
			} else {
				return false;
			}
		}
	}

	public function getWorkInProgressTaskList( $userid){
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '".$userid."' AND  `status` = '20'  AND type !='bug' group by	`task_no`");
		return $qry->result_array();
	}
	public function getBugWorkInProgressTaskList($userid)
	{
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '" . $userid . "' AND type='bug' AND  `status` = '20' group by	`task_no`");
		return $qry->result_array();
	}

	public function getsendbackTaskList($userid)
	{
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '" . $userid . "' AND  `status` IN(21,51) group by task_id");
		return $qry->result_array();
	}

	public function getIndTaskdetail($taskno, $userid)
	{
		$condition = '';
		if (!empty($taskno)) {
			$condition = "AND `task_no` = '" . $taskno . "'";
		}

		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '" . $userid . "'  $condition AND `status` IN (10,20, 21,51)");
		//echo $this->db->last_query();
		return $qry->row();
	}
	public function getIndTaskSummary($taskno, $userid, $taskid)
	{
		if (!empty($taskid)) {
			$condition = "AND `task_id` = '" . $taskid . "' AND `task_no` = '" . $taskno . "'";
		} else {
			$condition = "AND `task_no` = '" . $taskno . "'";
		}
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '" . $userid . "' $condition AND `status` IN(10,20,80,81,21,51)");
		//echo $this->db->last_query();
		return $qry->result_array();
	}

	public function getIndsendbackcomments($taskno,$taskid)
	{
		if (!empty($taskno)) {
			$condition = " `task_no` = '".$taskno."' ";
		} else {
			$condition = " `task_id` = '".$taskid."'";
		}
		$qry = $this->db->query("SELECT * FROM `task_testing` WHERE $condition");
	//	echo $this->db->last_query();
		return $qry->result_array();
	}

	public function updateselectsummary($taskid, $status, $task_status, $taskno, $userid, $critical){
		$update_date = date("Y-m-d H:i:s");
		$status1 = ",`status` = 20";
		if($critical == 1){
			$condition = "task_no='".$taskno."'";

		}
		else{
			$condition = " task_id='".$taskid."'";

		}
		$qry = $this->db->query("UPDATE `task_allocation` SET  `developer_status` = '".$status."' $status1  WHERE $condition ");
		if ($qry) {
			$selectqry = $this->db->query("SELECT * FROM `task_log`WHERE end_task IS NULL AND task_status = 'dev_begin' AND `user_id` ='".$userid."' AND `task_flag` = 0");
			if ($selectqry->num_rows() > 0) {
				$result = $selectqry->row();
				$starttimestamp = strtotime($result->task_date);
				$endtimestamp = strtotime($update_date);
				$timediff = abs($endtimestamp - $starttimestamp);
				$hours = floor($timediff / 3600);
				$minutes = floor(($timediff % 3600) / 60);
				$seconds = $timediff % 60;
				$duration = sprintf('%02d:%02d:%02d', $hours, $minutes, $seconds);
				//$duration = gmdate('H:i:s', $timediff);
				$statusUpdate = $this->db->query("UPDATE `task_log` SET `task_duration`= '".$duration."',`end_task` = '". $update_date."' WHERE task_status = 'dev_begin' AND `end_task` IS NULL AND`user_id` ='". $userid."' AND `task_id` = '". $result->task_id."' AND `task_no` = '".$result->task_no."' AND `task_flag` = 0");
			//	echo $this->db->last_query();
				if($statusUpdate){
					$this->db->query("UPDATE `task_allocation` SET  `developer_status` = 0 WHERE `assign_id` ='" . $userid . "' AND `task_id` = '" . $result->task_id . "' AND `task_no` = '" . $result->task_no . "'");
					//$this->db->query("INSERT INTO `task_log`(
					//`task_id`,
					//`task_no`,
					//`task_date`,
					//`task_status`,
					//`user_id`)
					// VALUES (
					//'".$result->task_id."',
					//'".$result->task_no."',
					//'".$update_date."',
					//'dev_end',
					//'".$userid."')");
				}
			}
			$this->db->query("INSERT INTO `task_log`(
				`task_id`,
				`task_no`,
				`task_date`,
				`task_status`,
				`user_id`)
			     VALUES (
				'".$taskid."',
				'".$taskno."',
				'".$update_date."',
				'".$task_status."',
				'".$userid."')");
			return true;
		} else {
			return false;
		}
	}

	public function Updatetaskprogressdata( $taskid, $status, $task_status, $taskno,$userid, $critical){
		$condition = '';
		if($critical == 1) {
			$condition = ", `critical_update` = '0'";
          $task_status = 'dev_complete';
		}

		$update_date = date("Y-m-d H:i:s");
		$qry = $this->db->query("UPDATE `task_allocation` SET  `developer_status` = '". $status."' $condition WHERE task_id='". $taskid."'");
		if($qry){
			$sql1 = $this->db->query("SELECT task_no FROM `task_allocation` WHERE task_id='".$taskid."'");
			$task_no = $sql1->row()->task_no;
			$sql = $this->db->query("SELECT * FROM `task_allocation` WHERE `task_no` = '". $task_no."' and status IN (20,21,51) and developer_status IN (0,80)");
			if ($sql->num_rows() == 0) {
				$qry = $this->db->query("UPDATE `task_allocation` SET `status` = 30 WHERE `task_no` = '". $task_no."'");
			}
			$selectqry = $this->db->query("SELECT * FROM `task_log` WHERE `user_id` = '".$userid."' and `task_status`='dev_begin' AND `task_duration` IS NULL AND `task_flag` = '0' order by `task_log_id` DESC limit 1");
			//$selectqry = $this->db->query("SELECT * FROM `task_log` WHERE end_task IS NULL AND  task_duration IS NULL AND task_status = 'dev_begin' AND `user_id` ='".$userid."' AND `task_no` ='". $taskno."' AND `task_id` = '". $taskid."' AND `task_flag` = 0");
			if ($selectqry->num_rows() > 0) {
				$result = $selectqry->row();
				$starttimestamp = strtotime($result->task_date);
				$endtimestamp = strtotime($update_date);
				$timediff = abs($endtimestamp - $starttimestamp);
				$hours = floor($timediff / 3600);
				$minutes = floor(($timediff % 3600) / 60);
				$seconds = $timediff % 60;
				$duration = sprintf('%02d:%02d:%02d', $hours, $minutes, $seconds);
				//$duration = gmdate('H:i:s', $timediff);
				$statusUpdate = $this->db->query("UPDATE `task_log` SET `task_duration`= '" . $duration . "' ,`end_task` = '" . $update_date . "' WHERE task_status = 'dev_begin' AND `user_id` ='" . $userid . "' AND `end_task` IS NULL AND `task_flag` = '0' AND `task_id` = '" . $result->task_id . "' AND `task_no` = '".$result->task_no."'");
			}
			$this->db->query("INSERT INTO `task_log`(
				`task_id`,
				`task_no`,
				`task_date`,
				`task_status`,
				`user_id`)
			     VALUES (
				'".$taskid."',
				'".$taskno."',
				'".$update_date."',
				'".$task_status."',
				'".$userid."')");
			return true;
		}
		else{
			return false;
		}
	}

	public function gettestpendingTaskList($userid)
	{
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '" . $userid . "' AND `status` = '30' AND type !='bug' group by `task_no`");
		return $qry->result_array();
	}

	public function getbugtestpendingTaskList($userid)
	{
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '" . $userid . "' AND `status` = '30' AND type ='bug'   group by	`task_no`");
		return $qry->result_array();
	}
	public function getcriticalTaskdetail($taskno, $userid)
	{
		$condition = '';
		if (!empty($taskno)) {
			$condition = "AND `task_no` = '" . $taskno . "'";
		}

		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '" . $userid . "'  $condition AND `status` IN(10,20) AND `critical_update` = 1 ");
		return $qry->row();
	}
	public function getcriticalTaskSummary($taskno, $userid, $taskid)
	{
		if (!empty($taskno)) {
			$condition = "AND `task_no` = '" . $taskno . "'";
		} else {
			$condition = "AND `task_id` = '" . $taskid . "'";
		}
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `assign_id` = '" . $userid . "' $condition AND `critical_update` = 1");
		return $qry->result_array();
	}

	public function getWorkUpdation($userid){
		$r_from_date = date("Y-m-d", strtotime($this->input->post('report_date_from')));
		$r_date_to = date("Y-m-d", strtotime($this->input->post('report_date_to')));
		$today = date("Y-m-d");
		$condtion = '';
		$todaycon = ($r_from_date == $r_date_to ? $today : '');
		if ($todaycon != '') {
			if($r_from_date == $r_date_to  ){
				$condtion .= " AND date(`task_date`) = '$r_date_to'";
			}
			else{
				$condtion .= " AND date(`task_date`) <= '$todaycon'";
			}
		} else {
			if ($r_from_date != '' && $r_date_to == '') {
				$condtion .= " AND date(`task_date`) >= '$r_from_date'";
			}
			if ($r_date_to != '' && $r_from_date == '') {
				$condtion .= " AND date(`task_date`) <= '$r_date_to'";
			}
			if ($r_from_date != '' && $r_date_to != '') {
				$condtion .= " AND date(`task_date`) >= '$r_from_date'  AND date(`task_date`) <= '$r_date_to'";
			}
		}
		$qry = $this->db->query("SELECT *,SEC_TO_TIME(SUM(TIME_TO_SEC(task_duration))) as hours FROM `task_log` WHERE  `task_status` IN ('dev_begin','dev_complete') AND `user_id` = '".$userid."' $condtion  group by date(task_date),user_id,task_no ORDER BY task_date desc");
		return $qry->result_array();
	}
	public function getWorkUpdationTaskallocation($task_id, $task_no, $assign_id)
	{
		$qry = $this->db->query("SELECT * FROM task_allocation WHERE task_no = '" . $task_no . "' AND task_id = '" . $task_id . "' AND assign_id = '" . $assign_id . "' ");
		return $qry->row();
	}
	public function getTaskbegin($task_no, $task_id, $userid){
		$qry = $this->db->query("SELECT * FROM `task_log` WHERE `task_no`='$task_no'  AND `user_id` = '$userid' AND `task_status` = 'dev_begin' AND `end_task` IS NULL AND `task_duration` IS NULL ");
		if($qry->num_rows() > 0){
			return $qry->row();
		}
		else{
			return false;
		}		
	}
	public function isopened($taskno, $userid, $taskid){
		$res = $this->db->query("SELECT *  FROM `task_log` WHERE `user_id` = '$userid' and task_no = '$taskno' and `task_status`='dev_begin' ORDER BY task_no DESC LIMIT 1");
		//echo $this->db->last_query();
		if($res->num_rows() > 0){
			return $res->row();
		}
		else{
			return false;
		}
	}
	public function ischeckpickedTask($taskno, $userid){
		$res =$this->db->query("SELECT `task_status`,user_id FROM `task_log` WHERE  `user_id` = '$userid' AND task_no = '$taskno' AND `task_status` = 'dev_pick' group by task_no");
		
 		if($res->num_rows() > 0){
			return $res->row();
		}
		else{
			return false;
		}
	}
}
?>