<?php
class Proforma_model extends CI_Model {

	function __construct()
	{
		// Call the Model constructor
		parent::__construct();

	}

	// select records count (for pagination)
	    function get_count($table_name = '', $where=array()){
		$rs = $this->db->get_where($table_name,$where);
		return $rs->num_rows();
	}

	public function getJobData($no){
		$query= $this->db->query("SELECT j.job_card_amount_with_vat,p.`proforma_amount`-sum(p.`proforma_percentage_amount`) as amount FROM `job_card` j left join `proforma` p on p.job_card_id=j.id WHERE (p.proforma_status='1' OR p.proforma_status='2' ) and j.`id`='$no' ");
		return $query->row();
	}

	public function jobCardRow($id) {
		$query= $this->db->query("SELECT j.*,ncm.client_name FROM `job_card` j inner join `new_client_master` ncm on ncm.client_id=j.client_id WHERE j.`id` ='$id'");
		return $query->row();
	}

	public function getProformaRow($id) {
		$query= $this->db->query("SELECT p.*,j.`job_card_number`,j.`job_card_total`,j.`job_card_vat_amount`,j.`job_card_amount_with_vat`,ncm.`tax_perce` FROM `proforma` p left join `new_client_master` ncm on ncm.`client_id`=p.`client_id` left join `job_card` j on j.id=p.job_card_id WHERE p.`proforma_id` ='$id'");
		return $query->row();
	}

	public function jobCardDetails($id) {
		$query= $this->db->query("SELECT * FROM `job_card_details` WHERE `job_card_id` ='$id'");
		return $query->result();
	}

	public function invoice($from,$to,$client_id,$division,$nbuser_id)
	{
		///replace with proper function when calling from controller////  
		//echo "<br>Arguments ".$from."argto".$to."******<br>";
		$date = $from;
		$date1 = explode('/',$date);
	    $from =  $date1[2] . '-' . $date1[0] . '-' . $date1[1];

		$date = $to;
		$date1 = explode('/',$date);
	    $to =  $date1[2] . '-' . $date1[0] . '-' . $date1[1];

		///	echo "<br>fromdate ".$from." to    ".$to."<br>";

 		if($division!='select'){
			$furniture_invoicesql=" AND furniture_invoice.quotation_divisionid='$division'";
		} else {
			$furniture_invoicesql='';
		}
		if($nbuser_id!=''){
			$furniture_invoicesql.=" AND furniture_invoice.created_id='$nbuser_id'";
		} else {
			$furniture_invoicesql.='';
		}
		
		/////////end
		$this->load->database();
		$flag=true;
 		$sql= "SELECT IFNULL(SUM(invoice_percentage_amount-invoice_discount),0) as debit FROM furniture_invoice WHERE DATE(invoice_date)<'".$from."' AND  furniture_invoice.client_id='".$client_id."' ".$furniture_invoicesql." AND invoice_status!=1";

		$result=$this->db->query($sql);
		if($result->num_rows()>0)
		{
			$records = $result->result_array();
			foreach($records as $record)
			{
				$dr = $record['debit'];
			}
		}
		$sql="SELECT IFNULL(SUM(receipt_amount+furniture_receipts.receipt_discount),0)+IFNULL(SUM(furniture_invoice.total_credit_note_amount),0) as credit FROM furniture_receipts  INNER JOIN furniture_invoice ON furniture_invoice.invoice_id=furniture_receipts.invoice_id WHERE DATE(receipt_date)<'".$from."' AND furniture_invoice.client_id='".$client_id."' ".$furniture_invoicesql." AND furniture_invoice.invoice_status!=1 AND furniture_receipts.receipt_status!=0";
		$result=$this->db->query($sql);
			if($result->num_rows()>0)
		 	{
				$records = $result->result_array();
				foreach($records as $record)
				{
					$cr = $record['credit'];
				}
		 	}
		  	$open=$dr-$cr;
		 	if($dr==0 && $cr==0)
		 	{
				$flag=false;
			}
		  	if( $open>=0)
		  	{
	   			$sql="SELECT '".$from."' DATE, '' transaction_id, '' inv_div_code, 'Opening Bal.' TYPE,   $open amount_dr, '' amount_cr
UNION
(SELECT * FROM (
SELECT   DATE(invoice_date) DATE, Invoice_number transaction_id,company_division.division_code as inv_div_code, 'Invoice' TYPE, (invoice_percentage_amount-invoice_discount) amount_dr, '' amount_cr FROM furniture_invoice JOIN company_division ON company_division.division_id=furniture_invoice.quotation_divisionid
WHERE DATE(invoice_date) >='".$from."' AND DATE(invoice_date)<='".$to."' AND furniture_invoice.client_id=".$client_id." ".$furniture_invoicesql." AND furniture_invoice.invoice_status!=1
UNION
SELECT DATE(receipt_date) DATE, receipt_number transaction_id,company_division.division_code as inv_div_code, 'Receipt' TYPE, '' amount_dr, SUM(receipt_amount+furniture_receipts.receipt_discount) amount_cr FROM furniture_receipts JOIN company_division ON company_division.division_id=furniture_receipts.quotation_divisionid
INNER JOIN furniture_invoice ON furniture_invoice.invoice_id=furniture_receipts.invoice_id WHERE DATE(receipt_date) >='".$from."'  AND DATE(receipt_date) <='".$to."' AND furniture_invoice.client_id=".$client_id." ".$furniture_invoicesql." AND furniture_receipts.receipt_status!=0
GROUP BY receipt_number
UNION
SELECT DATE(credit_note_date) DATE, credit_note_number transaction_id,company_division.division_code as inv_div_code, 'Credit Note' TYPE, '' amount_dr, SUM(credit_note.net_amount) amount_cr FROM credit_note JOIN company_division ON company_division.division_id=credit_note.quotation_divisionid 
INNER JOIN furniture_invoice ON furniture_invoice.invoice_id=credit_note.invoice_id WHERE DATE(credit_note_date) >='".$from."'  AND DATE(credit_note_date) <='".$to."' AND furniture_invoice.client_id=".$client_id." ".$furniture_invoicesql." AND credit_note.credit_note_status!=0 
GROUP BY credit_note_number
) a ORDER BY DATE) ORDER BY DATE ASC";


		  }


		 else
		 {
	  $open=$cr-$dr;


  	$sql="SELECT '".$from."' DATE, '' transaction_id, '' inv_div_code, 'Opening Bal.' TYPE,   $open amount_dr, '' amount_cr
UNION
(SELECT * FROM (
SELECT   DATE(invoice_date) DATE, Invoice_number transaction_id,company_division.division_code as inv_div_code, 'Invoice' TYPE, (invoice_percentage_amount-invoice_discount) amount_dr, '' amount_cr FROM furniture_invoice JOIN company_division ON company_division.division_id=furniture_invoice.quotation_divisionid
WHERE DATE(invoice_date) >='".$from."' AND DATE(invoice_date)<='".$to."' AND furniture_invoice.client_id=".$client_id." ".$furniture_invoicesql." AND furniture_invoice.invoice_status!=1
UNION
SELECT DATE(receipt_date) DATE, receipt_number transaction_id,company_division.division_code as inv_div_code, 'Receipt' TYPE, '' amount_dr, SUM(receipt_amount+furniture_receipts.receipt_discount) amount_cr FROM furniture_receipts JOIN company_division ON company_division.division_id=furniture_receipts.quotation_divisionid
INNER JOIN furniture_invoice ON furniture_invoice.invoice_id=furniture_receipts.invoice_id WHERE DATE(receipt_date) >='".$from."'  AND DATE(receipt_date) <='".$to."' AND furniture_invoice.client_id=".$client_id." ".$furniture_invoicesql." AND furniture_receipts.receipt_status!=0
GROUP BY receipt_number
UNION
SELECT DATE(credit_note_date) DATE, credit_note_number transaction_id,company_division.division_code as inv_div_code, 'Credit Note' TYPE, '' amount_dr, SUM(credit_note.net_amount) amount_cr FROM credit_note JOIN company_division ON company_division.division_id=credit_note.quotation_divisionid 
INNER JOIN furniture_invoice ON furniture_invoice.invoice_id=credit_note.invoice_id WHERE DATE(credit_note_date) >='".$from."'  AND DATE(credit_note_date) <='".$to."' AND furniture_invoice.client_id=".$client_id." ".$furniture_invoicesql." AND credit_note.credit_note_status!=0 
GROUP BY credit_note_number
) a ORDER BY DATE)";

	 }

		$result=$this->db->query($sql);
		//echo $this->db->last_query();
		//print_r($result->row());
		$records = $result->result_array();
		return $records;
	}
	public function invoice22($from,$to,$client_id,$division,$nbuser_id)
	{


	///replace with proper function when calling from controller////





		//echo "<br>Arguments ".$from."argto".$to."******<br>";
		$date = $from;
		$date1 = explode('/',$date);
	    $from =  $date1[2] . '-' . $date1[0] . '-' . $date1[1];



		$date = $to;
		$date1 = explode('/',$date);
	    $to =  $date1[2] . '-' . $date1[0] . '-' . $date1[1];

	///	echo "<br>fromdate ".$from." to    ".$to."<br>";


		if($division!='select'){
			$furniture_invoicesql=" AND furniture_invoice.quotation_divisionid='$division'";
			$furniture_quotationsql=" AND furniture_quotation.quotation_divisionid='$division'";
		} else {
			$furniture_invoicesql='';
			$furniture_quotationsql='';
		}
		
		if($nbuser_id!=''){
			$furniture_invoicesql.=" AND furniture_invoice.created_id='$nbuser_id'";
			$furniture_quotationsql.=" AND furniture_quotation.salesman_id='$nbuser_id'";
		} else {
			$furniture_invoicesql.='';
			$furniture_quotationsql.='';
		}

		/////////end

		 $this->load->database();



	$flag=true;


 $sql= "SELECT IFNULL(SUM(invoice_percentage_amount-invoice_discount),0) as debit FROM furniture_invoice WHERE DATE(invoice_date)<'".$from."' AND  furniture_invoice.client_id='".$client_id."' ".$furniture_invoicesql." AND invoice_status!=1";

		 $result=$this->db->query($sql);
		 if($result->num_rows()>0)
		 {

			$records = $result->result_array();
			foreach($records as $record)
			{
				$dr = $record['debit'];


			}
		 }


$sql="SELECT IFNULL(SUM(receipt_amount+furniture_receipts.receipt_discount),0) as credit FROM furniture_receipts  INNER JOIN furniture_invoice ON furniture_invoice.invoice_id=furniture_receipts.invoice_id WHERE DATE(receipt_date)<'".$from."' AND furniture_invoice.client_id='".$client_id."' ".$furniture_invoicesql." AND furniture_invoice.invoice_status!=1 AND furniture_receipts.receipt_status!=0";
		$result=$this->db->query($sql);
		 if($result->num_rows()>0)
		 {

			$records = $result->result_array();
			foreach($records as $record)
			{
				$cr = $record['credit'];

			}
		 }


		  $open=$dr-$cr;
		 if($dr==0 && $cr==0)
		 {
		$flag=false;
		}




		  if( $open>=0)
		  {



	   $sql="SELECT quotation_CONFIRMATIONDATE DATE, (QUOTATION_NUMBER) transaction_id,company_division.division_code as inv_div_code,
           'Confirmed Quote' TYPE, (quotation_total - quotation_discount) amount_dr, '' amount_cr
           FROM `furniture_quotation` JOIN company_division ON company_division.division_id=furniture_quotation.quotation_divisionid
INNER JOIN new_client_master ON new_client_master.client_id=furniture_quotation.client_id
WHERE quotation_status = 'Confirmed' AND furniture_quotation.client_id=".$client_id." ".$furniture_quotationsql."  AND quotation_date between '".$from."' and '".$to."' and
furniture_quotation.id NOT IN (SELECT quotation_id FROM furniture_invoice where furniture_quotation.client_id='".$client_id."')";


		  }


		 else
		 {
	  $open=$cr-$dr;


  	$sql="SELECT quotation_CONFIRMATIONDATE DATE, (QUOTATION_NUMBER) transaction_id,company_division.division_code as inv_div_code, 'Confirmed Quote' TYPE, (quotation_total - quotation_discount) amount_dr, '' amount_cr FROM `furniture_quotation` JOIN company_division ON company_division.division_id=furniture_quotation.quotation_divisionid
WHERE quotation_status = 'Confirmed' AND  furniture_quotation.client_id=".$client_id." ".$furniture_quotationsql." and quotation_date between '".$from."' and '".$to."' and
furniture_quotation.id NOT IN (SELECT quotation_id FROM furniture_invoice where furniture_quotation.client_id='".$client_id." ')";

	 }



		$result22=$this->db->query($sql);
		//echo $this->db->last_query();
		//print_r($result->row());
		$records22 = $result22->result_array();



		
		return $records22;
	}
	public function selectcount(){  
		$this->db->from('proforma');
		$cnt = $this->db->count_all_results();
		$invice_no = $cnt+1;
		return $invice_no;
    }
	public function list_details($id){  
		$this->db->select('*');
		$this->db->from('proforma');
		$this->db->join('proforma_details', 'proforma_details.proforma_id = proforma.proforma_id','inner');
		$this->db->where('proforma.proforma_id', $id);
		//$this->db->where('view_furniture_job_card.quotation_status', 'Confirmed');
		$this->db->order_by('group_id', 'ASC');
		$this->db->group_by('group_id'); 
		$query = $this->db->get();
		return $query;  
	}

	public function list_job_details($id){  
		$this->db->select('*');
		$this->db->from('view_furniture_job_card');
		$this->db->join('job_card_details', 'job_card_details.job_card_id = view_furniture_job_card.job_card_id','inner');
		$this->db->where('view_furniture_job_card.job_card_id', $id);
		//$this->db->where('view_furniture_job_card.quotation_status', 'Confirmed');
		$this->db->order_by('ex_furniture_area', 'ASC');
		$this->db->group_by('ex_furniture_area'); 
		$query = $this->db->get();
		return $query;  
	}
	public function list_tets_details($id){  
		$this->db->select('*');
		$this->db->from('view_furniture_quotations_client_project_users');
		$this->db->join('furniture_items', 'furniture_items.quotation_id = view_furniture_quotations_client_project_users.quotation_id','inner');
		$this->db->where('view_furniture_quotations_client_project_users.quotation_id', $id);
		$this->db->where('view_furniture_quotations_client_project_users.quotation_status', 'Confirmed');
		$this->db->order_by('ex_furniture_area', 'ASC');
		$this->db->group_by('ex_furniture_area'); 
		$query = $this->db->get();
		return $query;   
	}
	public function getonerow($id){  
		$this->db->where('id',$id);
		//$this->db->where('job_card_status','Confirmed');
		$this->db->join('new_client_master', 'new_client_master.client_id = job_card.client_id','left');
		$query = $this->db->get('job_card');  
		return $query->row();  
    }

	public function getsumrow($quotation_number,$client) {  
		$sql= "SELECT SUM(proforma.proforma_amount) as invoiceamount,SUM(proforma.paid_amount) as total_paid_amount,company_division.currency_code as invoice_currency_code,proforma_discount,SUM(qoute_discount) as qoute_discount,SUM(proforma_percentage) AS proforma_percentage FROM proforma JOIN company_division ON company_division.division_id=proforma.quotation_divisionid WHERE proforma.job_card_id='".$quotation_number."' AND (proforma.proforma_status=0 OR proforma.proforma_status=2) AND proforma.job_card_id!=0";
		$result=$this->db->query($sql);
		return $result->row();   
    } 
	public function client_data_submit() {
		$data = array(
			'client_name' => $this->input->post('client_name'),
			'client_email'=>$this->input->post('email_id'),
			'client_telephone1' => $this->input->post('telephone_1'),
			'client_telephone2'=>$this->input->post('telephone_2'),
			'client_address' => $this->input->post('address'),
			'client_fax'=>$this->input->post('fax'),
			'contact_person'=>$this->input->post('contact_person')
		);
		$this->db->insert('new_client_master',$data);  
	}

	public function get_invoice_no($quotation_divisionid,$invtype) {
		$this->db->where('quotation_divisionid',$quotation_divisionid,'from_proforma',$invtype);
		$this->db->from('furniture_invoice');
		$cnt = $this->db->count_all_results();
		$query= $this->db->query("SELECT * FROM  `company_division` WHERE division_id='$quotation_divisionid' ");
		$division_code=$query->row()->division_code;
		if($quotation_divisionid==7){
			$invice_no = $division_code.'-'.sprintf("%'.04d", ($cnt+6278));
		} else {
			$invice_no = $division_code.'-'.sprintf("%'.05d", ($cnt+1)).'-INV';
			//$invice_no = 'IN'.$division_code.'-'.sprintf("%'.04d", ($cnt+1));
		}
		return $invice_no;
	}

	public function pupdate($id){
		
		$this->db->select('*');
		$this->db->where(array('proforma_id'=>$id));
		$this->db->from('proforma');
		$rs = $this->db->get();
		if($rs->row()->proforma_id){
			//customer ledger amount
			$customer_ledger_amount=$rs->row()->proforma_percentage_amount;
			//sales ledger amount
			if($rs->row()->proforma_percentage!=100){
				$sales_ledger_amount	=	$rs->row()->proforma_percentage_amount-$rs->row()->proforma_vat_amount;
			} else {
				$sales_ledger_amount	=	$rs->row()->item_amount-$rs->row()->qoute_discount;
				//$sales_ledger_amount	=	$rs->row()->item_amount;
			}
			//vat ledger amount
			$ledger_vat =	$rs->row()->proforma_vat_amount;
			if(round($customer_ledger_amount-($sales_ledger_amount+$ledger_vat),3)==0){
				$invtype=$this->input->post('invtype');
				$invice_no	=	$this->get_invoice_no($rs->row()->quotation_divisionid,$invtype);

				$invoice_date = strtotime( $this->input->post('invoice_date') );
				$mysqldate = date( 'Y-m-d', $invoice_date );

				$data = array(
					'quotation_divisionid' 			=> $rs->row()->quotation_divisionid,
					'invoice_number'       			=> $invice_no,
					'invoice_date'         			=> $mysqldate,
					'quotation_id'         			=> $rs->row()->quotation_id,
					'job_card_id'         			=> $rs->row()->job_card_id,
					'invoice_amount'       			=> $rs->row()->proforma_amount,
					'invoice_percentage'            => $rs->row()->proforma_percentage,
					'invoice_percentage_amount'     => $rs->row()->proforma_percentage_amount,
					'invoice_vat_amount'   			=> $rs->row()->proforma_vat_amount,
					'invoice_discount'     			=> $rs->row()->proforma_discount,
					'qoute_discount'       			=> $rs->row()->qoute_discount,
					'client'               			=> $rs->row()->client,
					'client_id'            			=> $rs->row()->client_id,
					'proforma_id'          			=> $id,
					'from_proforma'        			=> 1,
					'po_no'     					=> $this->input->post('po_no'),
					'invoice_created_by'   			=> $this->session->userdata('user_name'),
					'created_id'           			=> $this->session->userdata('user_id')
				);
				
				$this->db->insert('furniture_invoice',$data);  
				$insert_id = $this->db->insert_id();

				$log_data=array(
					'trans_no'  	=>  $invice_no,
					'trans_type'  	=>  'Invoice',
					'trans_op'  	=>  'Create',
					'trans_user_id' =>  $this->session->userdata('user_id')
				);
				
				$log_for_transactions=$this->crud_model->insert('log_for_transactions',$log_data);


				$division_id=$rs->row()->quotation_divisionid;
				$div_data = $this->db->query("SELECT * FROM `company_division` WHERE division_id='$division_id' ");
				$division_code=$div_data->row()->division_code;  	

				$cust_bill_allocations_data = array(
					'customer_code'  => $this->input->post('client_code'),
					'bill_id'        => $insert_id,
					'trn_no'       	 => $invice_no,
					'bill_date'      => $mysqldate,
					'bill_amt'       => $rs->row()->proforma_percentage_amount,
					'bill_os_amount' => $rs->row()->proforma_percentage_amount,
					'division_id' 	 => $rs->row()->quotation_divisionid,
					'sm_id'     	 => $this->input->post('salesman_id'),
					'po_no'     	 => $this->input->post('po_no'),
					'bill_type'      => 'Invoice',
					'trn_type'       => 'Invoice'
				);
		
				$this->db->insert('cust_bill_allocations',$cust_bill_allocations_data);

				

				$user_id	=	$this->session->userdata('user_id');
				if($this->input->post('client_code')!=''){
					$this->db->where("vch_no",$invice_no);
					$this->db->where("vch_type",'SALES');
					$this->db->delete('accounts');
					$accounts_data = array(
						'vch_type' 	  => 'SALES',
						'vch_no'  	  => $invice_no,
						'vch_date'    => $mysqldate,
						'vch_ref'     => $this->input->post('reference'),
						'ledger_code' => $this->input->post('client_code'),
						'rev_ledger_code' => 'S0001',
						'cc_code' 	  => 1,
						'div_code' 	  => $rs->row()->quotation_divisionid,
						'ledger_amount'  => $rs->row()->proforma_percentage_amount,
						'vch_narration'=> 'Auto entry from Invoice No '.$invice_no,
						'user_id' 	  => $user_id,
						'status'      => 1
					);
					$this->db->insert('accounts', $accounts_data);

					if($rs->row()->proforma_percentage!=100){
						$item_amount	=	$rs->row()->proforma_percentage_amount-$rs->row()->proforma_vat_amount;
					} else {
						$item_amount	=	$rs->row()->item_amount-$rs->row()->qoute_discount;
					}

					$accounts_data = array(
						'vch_type' 	  => 'SALES',
						'vch_no'  	  => $invice_no,
						'vch_date'    => $mysqldate,
						'vch_ref'     => $this->input->post('reference'),
						'ledger_code' => 'S0001',
						'rev_ledger_code' => $this->input->post('client_code'),
						'cc_code' 	  => 1,
						'div_code' 	  => $rs->row()->quotation_divisionid,
						'ledger_amount'   => -$item_amount,
						'vch_narration'=> 'Auto entry from Invoice No '.$invice_no,
						'user_id' 	  => $user_id,
						'status'      => 1
					);
					$this->db->insert('accounts', $accounts_data);
					
					$accounts_data = array(
						'vch_type' 	  => 'SALES',
						'vch_no'  	  => $invice_no,
						'vch_date'    => $mysqldate,
						'vch_ref'     => $this->input->post('reference'),
						'ledger_code' => 'V0001',
						'rev_ledger_code' => $this->input->post('client_code'),
						'cc_code' 	  => 1,
						'div_code' 	  => $rs->row()->quotation_divisionid,
						'ledger_amount' => -$rs->row()->proforma_vat_amount,
						'vch_narration'=> 'Auto entry from Invoice No '.$invice_no,
						'user_id' 	  => $user_id,
						'status'      => 1
					);
					$this->db->insert('accounts', $accounts_data);

					/* if($rs->row()->qoute_discount!=0){
						$accounts_data = array(
							'vch_type' 	  => 'SALES',
							'vch_no'  	  => $invice_no,
							'vch_date'    => $mysqldate,
							'vch_ref'     => $this->input->post('reference'),
							'ledger_code' => 'D0001',
							'rev_ledger_code' => $this->input->post('client_code'),
							'cc_code' 	  => 1,
							'div_code' 	  => 1,
							'ledger_amount'   => $rs->row()->qoute_discount,
							'vch_narration'=> 'Auto entry from Invoice No '.$invice_no,
							'user_id' 	  => $user_id,
							'status'      => 1
						);
						$this->db->insert('accounts', $accounts_data);
						
					} */

				}


				$this->db->select('*');
				$this->db->where(array('proforma_id'=>$id));
				$this->db->from('proforma_details');
				$this->db->order_by("id", "ASC");
				$sub_val 	   = $this->db->get();
				
				foreach($sub_val->result() as $sub_records){
					$item_tax_id=$this->input->post('p_tax_id_'.$id.'_'.$sub_records->id);
					$description=$this->input->post('p_description_'.$id.'_'.$sub_records->id);
					/* if($sub_records->vat_perce==10){
						$item_tax_id=3;
					} else {
						$item_tax_id=7;
					} */
					$datanew = array(
						'invoice_id' 	   => $insert_id,
						'sl_no' 		   => $sub_records->sl_no,
						'group_name' 	   => $sub_records->group_name,
						'group_id' 		   => $sub_records->group_id,
						'sub_group_name'   => $sub_records->sub_group_name,
						'sub_group_id' 	   => $sub_records->sub_group_id,
						'item_order' 	   => $sub_records->item_order,
						'item_name' 	   => $sub_records->item_name,
						'quantity' 		   => $sub_records->quantity,
						'amount' 		   => str_replace(",","",$sub_records->amount),
						'item_discount'    => str_replace(",","",$sub_records->item_discount),
						'vat_perce' 	   => str_replace(",","",$sub_records->vat_perce),
						'item_tax_id'	   => $item_tax_id,
						'vat_amount' 	   => str_replace(",","",$sub_records->vat_amount),
						'net_amount' 	   => str_replace(",","",$sub_records->net_amount),
						'description' 	   => $description,
						'internal_comments'=> $sub_records->internal_comments,
						'uom' 			   => $sub_records->uom,
						'total_discount'   => $sub_records->total_discount
					);
					
					$this->db->insert('furniture_invoice_details',$datanew); 
				}

				$vat_return_data=array();
				$this->db->select('sum(amount)-sum(item_discount) as pu_amnt,vat_perce,item_tax_id,sum(vat_amount) as vat_amount');
				$this->db->from('furniture_invoice_details');
				$this->db->where('invoice_id',$insert_id);
				//$this->db->group_by('pu_ledger_code');
				$this->db->group_by('item_tax_id');
				$vatquery = $this->db->get();
				$vatResult = $vatquery->result_array();
				$user_id	=	$this->session->userdata('user_id');
				foreach ($vatResult as $key => $value2) {
					$vat_return_data[] = array(
						'vch_type' 	  => 'SALES',
						'vch_no'  	  => $invice_no,
						'vch_date'    => $mysqldate,
						'division_id' => $rs->row()->quotation_divisionid,
						'led_code' 	  => 'S0001',
						'tax_id'      => $value2['item_tax_id'],
						'taxable_amount'=> $value2['pu_amnt'],
						'tax_amount'  => $value2['vat_amount'],
						'created_date'=> date("Y-m-d h:m:s"),
						'user_id' 	  => $user_id,
						'status'      => 1
					);
				}
				if($vat_return_data){
					$this->db->insert_batch('vat_return', $vat_return_data);
				}

				$this->db->where('proforma_id',$id);
				$updatedata = array(
					'proforma_status' => 2
				);
				$this->db->update('proforma', $updatedata);
			} else {
				$this->session->set_flashdata('response', 'The Debit and Credit mismatch.Please contact Administrator...!');
				redirect('Invoices/create/'.$id);
			}
		}
	}
	public function get_proforma_no($quotation_divisionid) {
		$this->db->where('quotation_divisionid',$quotation_divisionid);
		$this->db->from('proforma');
		$cnt = $this->db->count_all_results();
		$query= $this->db->query("SELECT * FROM  `company_division` WHERE division_id='$quotation_divisionid' ");
		$division_code=$query->row()->division_code;
		$proforma_no = 'P'.date("y").$division_code.sprintf("%'.05d", ($cnt+1));
		return $proforma_no;
	}

	public function proforma_submit() {
				$this->db->where('quotation_divisionid',$this->input->post('textfield2'));
				$this->db->from('proforma');
				$cnt = $this->db->count_all_results();
				$invice_no = sprintf("%'.05d",$cnt+1);
				$invc_dat	=	date( "Y-m-d", strtotime($this->input->post('invoice_date')));
				//$inv_per_amnt	=	$this->input->post('inv_per_amnt');
				/*if(@$this->input->post('vat_amount2')===''){
						$na_inv_per_amnt	=	$this->input->post('inv_per_amnt')	-	$this->input->post('invoice_discount');
						$n_vat_amt	=	($na_inv_per_amnt-($this->input->post('vat_amount')*($this->input->post('invoicepercentage_2')/100)))*.05;
						$tes_amnt	=	$this->input->post('inv_per_amnt')+$n_vat_amt;
						$invoice_amount=str_replace(",","",$this->input->post('total_amount'));
				} else {
					
					if(@$this->input->post('pull_nb_item')==='1'){
						$invoice_amount2=str_replace(",","",$this->input->post('total_invoice_amnt'));
					} else {
						$invoice_amount2=str_replace(",","",$this->input->post('total_amount'));
					}
					$exclde_vat_amt	=	$this->input->post('total_invoice_amnt')/1.05;
					$n_vat_amt=$this->input->post('total_invoice_amnt')-$exclde_vat_amt;
					$total_discount_amount	=	$invoice_amount2-($exclde_vat_amt+$n_vat_amt);
					//$n_vat_amt	=	$na_inv_per_amnt*.05;
					$tes_amnt	=	$this->input->post('total_invoice_amnt')+$total_discount_amount;
					$invoice_amount	=	$this->input->post('total_invoice_amnt')+$total_discount_amount;
				}*/
				$invoicepercentage_2=$this->input->post('invoicepercentage_2');
				if($this->input->post('invoice_discount')!==''){
					$invoice_discount=$this->input->post('invoice_discount');
				} else {
					$invoice_discount=0;
				}
				if(@$this->input->post('pull_nb_item')==='1'){
					$total_invoice_amnt=str_replace(",","",$this->input->post('total_amount'));
					$qoute_discount=str_replace(",","",$this->input->post('qoute_discount'));
					$jvat_amount=$this->input->post('job_card_vat_perc');
					$nbinvamount=str_replace(",","",$this->input->post('nbinvamount'));
					$qtamount=$total_invoice_amnt-$qoute_discount;
					$testamnt=$qtamount+($qtamount*($jvat_amount/100));
					$net_amount = $testamnt-$nbinvamount;
					if($invoicepercentage_2==$this->input->post('invoicepercentage_1')){
						$ttxxx=($net_amount)/(1+($jvat_amount/100));
						$exldamnt	=	 $ttxxx-$invoice_discount;
					} else {
					   $exldamnt	=	((($invoicepercentage_2/100)*($testamnt))/1.05)-$invoice_discount;
					}
					//$exldamnt	=	(($invoicepercentage_2/100)*($total_invoice_amnt-$qoute_discount))-$invoice_discount;
				} else {
					$ttxxx=(($invoicepercentage_2/100)*($testamnt))/(1+($qvat_amount/100));
					$exldamnt	=	 $ttxxx-$invoice_discount;
					//$total_invoice_amnt=str_replace(",","",$this->input->post('total_amount'));
					//$exldamnt	=	(($invoicepercentage_2/100)*($total_invoice_amnt))-$invoice_discount;
				}
				$jvat_amount=$this->input->post('job_card_vat_perc');
				$n_vat_amt	= 	$exldamnt*($jvat_amount/100);
				$invoice_amount= ($exldamnt+$n_vat_amt)+$invoice_discount;
				$data = array(
				'quotation_divisionid' => $this->input->post('textfield2'),
				'proforma_number'       => $invice_no,
				'proforma_date'         => $invc_dat,
				'quotation_id'         => $this->input->post('quotation_number'),
				'job_card_id'         => $this->input->post('job_card_id'),
				'proforma_amount'       => $invoice_amount,
                'proforma_percentage'             => $this->input->post('invoicepercentage_2'),
                'proforma_percentage_amount'      => $invoice_amount,
				'proforma_vat_amount'     => $n_vat_amt,
				'proforma_discount'     => $this->input->post('invoice_discount'),
				'qoute_discount'       => $this->input->post('qoute_discount'),
				'client'               => $this->input->post('client'),
				'client_id'            => $this->input->post('client_id'),
				'proforma_created_by'   => $this->session->userdata('user_name'),
				'created_id'           => $this->session->userdata('user_id')
				);
				
				$this->db->insert('proforma',$data);  
				/*if($this->input->post('qoute_discount')!=0){
				$this->db->where('id',$this->input->post('quotation_number'));
				 $data_1 = array(
					'quotation_discount' => $this->input->post('qoute_discount')
				);
					$this->db->update('furniture_quotation', $data_1);
				}	*/
		$nbquotation_id	=$this->input->post('quotation_number');
		$this->db->where('id',$nbquotation_id);
		$pdata = array(
		   'is_proforma' => 1
	    );
		$this->db->update('furniture_quotation', $pdata);

		$SQL = "SELECT MAX(proforma_id) as `maxinvid` FROM proforma;";
		$result = $this->db->query($SQL);
		$inv = $result->result_array();
		
		$count = $this->input->post('hiddenCount');
		$maxinvid = $inv[0]['maxinvid'];
		
		if ($this->input->post('pull_itme_nabas')==='1'){
			$quotation_number    = $this->input->post('quotation_number');
			$h	=	$this->list_tets_details($quotation_number);
			foreach ($h->result() as $row) {
			//for($i=0; $i<=count($h->result()) ; $i++){
					$this->db->select('*');
					$this->db->where(array('quotation_id'=>$row->quotation_id,'ex_furniture_area'=>$row->ex_furniture_area));
					$this->db->from('furniture_items');
					$this->db->order_by("sub_group_id", "ASC");
					$this->db->group_by("sub_group");
					$rs = $this->db->get();
			foreach($rs->result() as $holi_per_mnth){ 
										
					$this->db->select('*');
					$this->db->where(array('quotation_id'=>$row->quotation_id,'ex_furniture_area'=>$row->ex_furniture_area,'sub_group_id'=>$holi_per_mnth->sub_group_id));
					$this->db->from('furniture_items');
					$this->db->order_by("furniture_id", "ASC");
					$sub_val 	   = $this->db->get();
					
					foreach($sub_val->result() as $sub_records){
					
					$datanew = array(
					'proforma_id' 		=> $maxinvid,
					'group_name' 		=> $sub_records->furniture_area,
					'group_id' 			=> $sub_records->ex_furniture_area,
					'sub_group_name' 	=> $sub_records->sub_group,
					'sub_group_id' 		=> $sub_records->sub_group_id,
					'item_order' 		=> $sub_records->item_order,
					'item_name' 		=> $sub_records->furniture_model,
					'quantity' 			=> $sub_records->furniture_quantity,
					'amount' 			=> str_replace(",","",$sub_records->furniture_unitprice),
					'description' 		=> $sub_records->furniture_description,
					'uom' 				=> $sub_records->uom,
					'total_discount' 	=> $sub_records->total_discount
					);
					
					$this->db->insert('proforma_details',$datanew); 
					}
			}
				
			}
		} else {
		
			for($i=0; $i<=$count ; $i++){
			   if($this->input->post('item_row'.$i)!=""){
				    $disc=$this->input->post('disc_row'.$i)/$this->input->post('quantity_row'.$i);
					   $rate_row=str_replace(",","",$this->input->post('rate_row'.$i));
				   //}
				   	if ($this->input->post('quotation_number')===''){
						$total_disc_na	=	($this->input->post('invoice_discount')*(($rate_row*$this->input->post('quantity_row'.$i)) - $disc))/$invoice_amount;
					} else {
						$total_disc_na	=	0;
					}
					$datanew = array(
					'invoice_id' 		=> $maxinvid,
					'group_name' 		=> $this->input->post('grp_name'.$i),
					'group_id' 			=> $this->input->post('grp_id'.$i),
					'sub_group_name' 	=> $this->input->post('subgrp_name'.$i),
					'sub_group_id' 		=> $this->input->post('subgrp_id'.$i),
					'item_name' 		=> $this->input->post('item_row'.$i),
					'quantity' 			=> $this->input->post('quantity_row'.$i),
					'amount' 			=> $rate_row-$disc,
					'description' 		=> $this->input->post('description_row'.$i),
					'uom' 				=> $this->input->post('uom'.$i),
					'total_discount' 	=> $total_disc_na
					);
					
					$this->db->insert('furniture_invoice_details',$datanew); 
				} 
			}
		}
			// MAILING ....

				$INVOICESQL = "SELECT company_division.division_code AS division_name,company_division.currency_code AS currency_name,furniture_invoice.client AS client,furniture_invoice.invoice_number AS invoice_number,furniture_invoice.invoice_amount AS invoice_amount,qoute_discount,invoice_percentage_amount,invoice_discount,furniture_quotation.project_name FROM furniture_invoice JOIN company_division ON company_division.division_id=furniture_invoice.quotation_divisionid LEFT JOIN furniture_quotation ON furniture_quotation.id=furniture_invoice.quotation_id WHERE furniture_invoice.invoice_id=".$maxinvid;
				$invoice_result = $this->db->query($INVOICESQL);
				$invoice_details = $invoice_result->result_array();
				$this->db->select('*');
				$this->db->from('emails'); 
				$query = $this->db->get();
				$records=$query->result_array();

				$links =   site_url('manage_quotation/printInvoiceDetails/'.$maxinvid.'/normal');
				/*	email notification start	*/
				//$this->load->library('tw_email');
				// send mail code
			/*	$from 		= ADMIN_MAIL;
				$fromname 	= 'Q-Pro Admin';
				$to 		= @$records[0]['invoice'];
				$subject 	= 'Q-Pro - Invoice for '.$invoice_details[0]['project_name'].'('.$invoice_details[0]['division_name'].' - '.$invoice_details[0]['invoice_number'].') is created';
				$message 	= '
				<table>
					<tr>
						<td>Invoice No.</td>
						<td>:</td>
						<td><a href='.$links.'>'.$invoice_details[0]['division_name'].' - '.$invoice_details[0]['invoice_number'].'</a></td>

					</tr>
					<tr>
						<td>Client</td>
						<td>:</td>
						<td>'.$invoice_details[0]['client'].'</td>
					</tr>
					<tr>
						<td>Item Total</td>
						<td>:</td>
						<td>'.$invoice_details[0]['currency_name'].'. '.number_format( $invoice_details[0]['invoice_amount'],2).'</td>
					</tr>
					<tr>
						<td>Quote Discount</td>
						<td>:</td>
						<td>'.$invoice_details[0]['currency_name'].'. '.number_format( $invoice_details[0]['qoute_discount'],2).'</td>
					</tr>
					<tr>
						<td>Invoice Amount</td>
						<td>:</td>
						<td>'.$invoice_details[0]['currency_name'].'. '.number_format( $invoice_details[0]['invoice_amount']-$invoice_details[0]['qoute_discount'],2).'</td>
					</tr>
					<tr>
						<td>Invoiced Amount</td>
						<td>:</td>
						<td>'.$invoice_details[0]['currency_name'].'. '.number_format( $invoice_details[0]['invoice_percentage_amount'],2).'</td>
					</tr>
					<tr>
						<td>Invoice Discount</td>
						<td>:</td>
						<td>'.$invoice_details[0]['currency_name'].'. '.number_format( $invoice_details[0]['invoice_discount'],2).'</td>
					</tr>
					<tr>
						<td><b>Net Amount</b></td>
						<td>:</td>
						<td>'.$invoice_details[0]['currency_name'].'. '.number_format( $invoice_details[0]['invoice_percentage_amount']-$invoice_details[0]['invoice_discount'],2).'</td>
					</tr>
				</table>';*/

				//$this->tw_email->send($from,$fromname,$to,$subject,$message);

				/*	email notification end		*/
    }
	public function invoice_getonerow($id){  
		$this->db->where('invoice_id',$id);
		$this->db->select('*');
		$this->db->from('furniture_invoice'); 
		$this->db->join('company_division','company_division.division_id = furniture_invoice.quotation_divisionid','inner');
		$this->db->join('new_client_master','new_client_master.client_id = furniture_invoice.client_id','left');
		$this->db->join('job_card','job_card.id = furniture_invoice.job_card_id','left');
		$this->db->join('furniture_quotation','furniture_quotation.id = furniture_invoice.quotation_id','left'); 
		$query = $this->db->get();  
		return $query->row();  
	} 
	public function pinvoice_getonerow($id){  
		$this->db->where('proforma_id',$id);
		$this->db->select('*');
		$this->db->from('proforma');
		$this->db->join('company_division','company_division.division_id = proforma.quotation_divisionid','inner');
		$this->db->join('new_client_master','new_client_master.client_id = proforma.client_id','left');
		$this->db->join('job_card','job_card.id = proforma.job_card_id','left');
		$this->db->join('furniture_quotation','furniture_quotation.id = proforma.quotation_id','left');
		$query = $this->db->get();  
		return $query->row();  
	} 
	public function list_pinvoice_details($id){  
		$this->db->select('*');
		$this->db->from('proforma_details');
		$this->db->where('proforma_id', $id); 
		$query = $this->db->get();
		
		return $query;  
	}

	public function group_pinvoice_details($id){  
		$this->db->select('*');
		$this->db->from('proforma_details');
		$this->db->where('proforma_id', $id); 
		$this->db->group_by('group_id'); 
		$query = $this->db->get();
		
		return $query;  
	}

	public function list_invoice_details($id){  
		$this->db->select('*');
		$this->db->from(' furniture_invoice_details');
		$this->db->where('invoice_id', $id); 
		$this->db->group_by('group_id'); 
		$query = $this->db->get();
		return $query;  
	}
	public function pinvoice_get_sum_amount($job_card_id)  
    {  
		$sql= "SELECT SUM(proforma.proforma_percentage_amount) as total_proformed_amount,SUM(proforma.proforma_vat_amount) as proforma_vat_amount FROM proforma WHERE proforma.job_card_id='".$job_card_id."' AND (proforma.proforma_status=1 OR proforma.proforma_status=2) ";
		$result=$this->db->query($sql);
		return $result->row();   
    } 
	public function update($id) {
	
		$this->db->where('invoice_id',$id);
		$this->db->delete('furniture_invoice');
		
		$this->db->where('invoice_id',$id);
		$this->db->delete('furniture_invoice_details');
				 
				 
		$data = array(
			'invoice_number' => $this->input->post('invoice_number'),
			'invoice_date' => date('Y-m-d h:m:s'),
			'quotation_id' => $this->input->post('quotation_number'),
			'invoice_amount' => str_replace(",","",$this->input->post('invce_amnt')),
			'client' => $this->input->post('client')
		);
				
		$this->db->insert('furniture_invoice',$data);  
			
		$SQL = "SELECT MAX(invoice_id) as `maxinvid` FROM furniture_invoice;";
		$result = $this->db->query($SQL);
		$inv = $result->result_array();
		
		$count = $this->input->post('hiddenCount');
		$maxinvid = $inv[0]['maxinvid'];
		
		for($i=0; $i<$count ; $i++){
			if($this->input->post('item_row'.$i)!=""){
				$datanew = array(
					'invoice_id' => $maxinvid,
					'item_name' => $this->input->post('item_row'.$i),
					'quantity' => $this->input->post('quantity_row'.$i),
					'amount' => str_replace(",","",$this->input->post('rate_row'.$i))
				);
				
				$this->db->insert('furniture_invoice_details',$datanew); 
			} 
		}
    }
	public function delete($id,$proforma_number){
		$this->db->where('proforma_id',$id);
			$data = array(
			'proforma_status' => 0,
			'proforma_cancelled_date' => date('Y-m-d h:m:s'),
			'proforma_cancelled_by' => $this->session->userdata('user_name')
		);
		$this->db->update('proforma', $data);
			
		$log_data=array(
			'trans_no'  	=>  $proforma_number,
			'trans_type'  	=>  'Proforma',
			'trans_op'  	=>  'Delete',
			'trans_user_id' =>  $this->session->userdata('user_id')

		);
		$log_for_transactions=$this->crud_model->insert('log_for_transactions',$log_data);
					
	}
		
}