<?php

class Report_model extends CI_Model {

	public function __construct() {

		// Call the Model constructor
		parent::__construct();
	}

	public function usersGroup(){
		$qry = $this->db->query("SELECT * FROM `users` WHERE   `user_status` = 'Enabled'");
		return $qry->result_array();
	}
	public function getClientdata()
	{
		$query = $this->db->query("SELECT `client_name`,`client_id` FROM `new_client_master`  order by client_name");
		return $query->result_array();

	}

	public function getTaskallocation($task_id, $task_no,$assign_id){
		$client_id = $this->input->post('client_id');
		$group = $this->input->post('group');
		$condtion = "";
		if ($client_id != '') {
			$condtion .= " AND `client_id` = '".$client_id."'";
		}
		
		$qry = $this->db->query("SELECT * FROM task_allocation WHERE task_no = '". $task_no."' AND task_id = '".$task_id."' AND assign_id = '". $assign_id."' $condtion ");
		//echo $this->db->last_query();
		if($qry->num_rows()>0){

		
		return $qry->row();
		}
	 
	}

	public function getstaffWorkUpdation(){
		$r_from_date = date("Y-m-d", strtotime($this->input->post('report_date_from')));
		$r_date_to =  date("Y-m-d", strtotime($this->input->post('report_date_to')));
		$today  =  date("Y-m-d");
		$user = $this->input->post('userid');
		$group = $this->input->post('group');
		$condtion = "";
		if ($user != '') {
			$condtion.= " AND `user_id` = '" . $user . "'";
		}
		$todaycon = ($r_from_date == $r_date_to  ? $today : '');
		if($todaycon !=''){
			if($r_from_date == $r_date_to  ){
				$condtion .= " AND date(`task_date`) = '$r_date_to'";
			}
			else{
				$condtion .= " AND date(`task_date`) <= '$todaycon'";
			}
		}
		else{
			if($r_from_date != '' && $r_date_to == ''){
				$condtion .= " AND date(`task_date`) >= '$r_from_date'";
			}
			if ($r_date_to != '' && $r_from_date == '') {
				$condtion .= " AND date(`task_date`) <= '$r_date_to'";
			}
			if ($r_from_date != '' && $r_date_to != '') {
				$condtion .= " AND date(`task_date`) >= '$r_from_date'  AND date(`task_date`) <= '$r_date_to'";
			}
		}
		if($group == 1){
			$qry = $this->db->query("SELECT *,SEC_TO_TIME(SUM(TIME_TO_SEC(task_duration))) AS  `hours` FROM `task_log` WHERE  task_status = 'dev_begin' $condtion group by date(task_date), user_id, task_id ORDER BY task_date desc");
			//echo $this->db->last_query();
		}
		else{
			$qry = $this->db->query("SELECT *,SEC_TO_TIME(SUM(TIME_TO_SEC(task_duration))) AS  `hours` FROM `task_log` WHERE  task_status = 'dev_begin' $condtion group by date(task_date),user_id,task_no ORDER BY task_date desc");
		}
		return $qry->result_array();
	}

	public function getTaskcompletestatus($task_id, $task_no, $assign_id){
		$r_from_date = date("Y-m-d", strtotime($this->input->post('report_date_from')));
		$r_date_to =  date("Y-m-d", strtotime($this->input->post('report_date_to')));
		$today  =  date("Y-m-d");
		$condtion = "";
		$todaycon = ($r_from_date == $r_date_to  ? $today : '');
		if($todaycon !=''){
			if($r_from_date == $r_date_to  ){
				$condtion .= " AND date(`task_date`) = '$r_date_to'";
			}
			else{
				$condtion .= " AND date(`task_date`) <= '$todaycon'";
			}
		}
		else{
			if($r_from_date != '' && $r_date_to == ''){
				$condtion .= " AND date(`task_date`) >= '$r_from_date'";
			}
			if ($r_date_to != '' && $r_from_date == '') {
				$condtion .= " AND date(`task_date`) <= '$r_date_to'";
			}
			if ($r_from_date != '' && $r_date_to != '') {
				$condtion .= " AND date(`task_date`) >= '$r_from_date'  AND date(`task_date`) <= '$r_date_to'";
			}
		}
		$qry = $this->db->query("SELECT * FROM `task_log` WHERE `user_id` = '$assign_id' AND task_id = '$task_id' AND `task_status` = 'dev_complete' $condtion ");
		return $qry->row();
	}

	public function getItemSummary(){
		$cate_id = $this->input->post('textfield2');
		$stock_group_id = $this->input->post('stock_group_id');
		$brand_id = $this->input->post('brand_id');
		$item_name = $this->input->post('item_name');
		$trans_date = $this->input->post('report_date_to');
		if(!empty($trans_date)){
			$report_date_from = date('Y-m-d', strtotime($trans_date));
			$daterange = "IT.trans_date <= '".$report_date_from."' AND";
		}
		else{
			$report_date_from = date('Y-m-d');
			$daterange = "IT.trans_date <= '".$report_date_from."' AND";
		}

		$conditon = '';

		if($cate_id != '') {
			$conditon.= "AND I.main_category = '".$cate_id."'";
		}
		if ($stock_group_id != '') {
            $conditon.= "AND I.brand_id ='".$stock_group_id."'";
		}
		if ($brand_id != '') {
            $conditon .= "AND I.stock_group_id = '".$brand_id."'";
		}
		if ($item_name != '') {
            $conditon .= "AND I.item_name like '%".$item_name."'";
		}



		$sql = "SELECT sum(IT.item_qty) as closing_stk,
			     IT.item_id,
				 IT.item_trans_id,
				 I.item_name,
				 I.id,
				 I.last_purchase_rate
			     FROM `item_trans` AS IT  LEFT JOIN `items` AS I ON I.id = IT.item_id WHERE $daterange IT.status = 1 AND I.id IS NOT NULL $conditon group by IT.item_id";
		$result = $this->db->query($sql);
	//	echo $this->db->last_query();
        return $result->result_array();
	}
	public function getItemList(){
		$cate_id = $this->input->post('textfield2');
		$stock_group_id = $this->input->post('stock_group_id');
		$brand_id = $this->input->post('brand_id');
		$item_name = $this->input->post('item_name');
		$inc_zero = $this->input->post('inc_zero');
		$trans_date = $this->input->post('report_date_to');
		if (!empty($trans_date)) {
			$report_date_from = date('Y-m-d', strtotime($trans_date));
			$daterange = "IT.trans_date <= '".$report_date_from."' AND";
		} else {
			$report_date_from = date('Y-m-d');
			$daterange = "IT.trans_date <= '".$report_date_from."' AND";

		}
		$conditon = "";
		if ($inc_zero == 1) {
			if ($cate_id != '') {
				$conditon .= "AND main_category =  '".$cate_id."'";
			}
			if ($stock_group_id != '') {
				$conditon .= "AND stock_group_id = '".$stock_group_id."'";
			}
			if ($brand_id != '') {
				$conditon .= "AND brand_id = '".$brand_id."'";
			}
		    if ($item_name != '') {
				$conditon .= "AND item_name like '%" .$item_name."'";
			}
			$sql = $this->db->query("SELECT * FROM `items` WHERE status = 1 $conditon");
		}
		else{
			if ($cate_id != '') {
				$conditon .= "AND I.main_category = '".$cate_id."'";
			}
			if ($stock_group_id != '') {
				$conditon .= "AND I.brand_id ='".$stock_group_id."'";
			}
			if ($brand_id != '') {
				$conditon .= "AND I.stock_group_id = '".$brand_id."'";
			}
			if ($item_name != '') {
				$conditon .= "AND I.item_name like '%".$item_name."'";
			}
			$sql = $this->db->query("SELECT * FROM ( SELECT sum(IT.item_qty) as closing_stk,
			     IT.item_id,
				 IT.item_trans_id,
				 I.item_name,
				 I.id,
				 I.last_purchase_rate
			     FROM `item_trans` AS IT  LEFT JOIN `items` AS I ON I.id = IT.item_id WHERE $daterange IT.status = 1 AND I.id IS NOT NULL $conditon group by IT.item_id) AS t WHERE closing_stk != '0'");
		}
		return $sql->result_array();

	}

	public function gettimesplitworkreport($task_no,$task_id,$task_date){
		$grpvalue = $this->input->post('grpvalue');
		if($grpvalue == 1){
			$sql = $this->db->query("SELECT * FROM `task_log` WHERE `task_id` = '$task_id' AND date(`task_date`)= '$task_date' AND `task_status` IN ('dev_begin','dev_complete') group by task_date");
		}
		else{
			$sql = $this->db->query("SELECT * FROM `task_log` WHERE `task_no` = '$task_no' AND date(`task_date`)= '$task_date' AND `task_status` IN ('dev_begin','dev_complete') group by task_date");
		}
		//echo $this->db->last_query();
		return $sql->result_array();
	}

	public function gettasksummaryname($task_no,$task_id){
		$qry = $this->db->query("SELECT * FROM `task_allocation` WHERE `task_no` = '$task_no'");
		return $qry->result_array();
	}

	public function getworkreportdailywise(){
		$r_from_date = date("Y-m-d", strtotime($this->input->post('report_date_from')));
		$r_date_to =  date("Y-m-d", strtotime($this->input->post('report_date_to')));
		$user = $this->input->post('userid');
		$condtion = "" ;

		if($r_from_date != '' && $r_date_to == ''){
			$condtion .= " AND date(`task_date`) >= '$r_from_date'";
		}
		if ($r_date_to != '' && $r_from_date == '') {
			$condtion .= " AND date(`task_date`) <= '$r_date_to'";
		}
		if ($r_from_date != '' && $r_date_to != '') {
			$condtion .= " AND date(`task_date`) >= '$r_from_date'  AND date(`task_date`) <= '$r_date_to'";
		}
		if ($user != '') {
			$condtion.= " AND `user_id` = '" . $user . "'";
		}
		//$qry = $this->db->query("SELECT *,SEC_TO_TIME(SUM(TIME_TO_SEC(task_duration))) AS  `hours` FROM `task_log` WHERE  task_status = 'dev_begin' $condtion group by date(task_date),user_id,task_no ORDER BY task_date desc");
		$qry = $this->db->query("SELECT *,
									DATE(task_date) as date,
									MIN(TIME(task_date)) as start_time,
									MAX(TIME(end_task)) as end_time,
									SEC_TO_TIME(SUM(TIME_TO_SEC(task_duration))) AS  `hours` 									 
									FROM `task_log` WHERE `status` = 1  $condtion group by date(task_date),user_id ORDER BY task_date desc");

									 
		return $qry->result_array();
	}

	public function gettaskerrorflagdata(){
		$r_from_date = date("Y-m-d", strtotime($this->input->post('report_date_from')));
		$r_date_to =  date("Y-m-d", strtotime($this->input->post('report_date_to')));
		$user = $this->input->post('userid');
		$condtion = "" ;
		$today  =  date("Y-m-d");
		$todaycon = ($r_from_date == $r_date_to  ? $today : '');
		if($todaycon !=''){
			if($r_from_date == $r_date_to && ($r_date_to != '1970-01-01' && $r_date_to != '0000-00-00')){
				$condtion .= " AND date(`task_date`) <= '$r_date_to'";
			}
			else{
				$condtion .= " AND date(`task_date`) <= '$todaycon'";
			}
		}
		else{
			if($r_from_date != '' && $r_date_to == ''){
				$condtion .= " AND date(`task_date`) >= '$r_from_date'";
			}
			if ($r_date_to != '' && $r_from_date == '') {
				$condtion .= " AND date(`task_date`) <= '$r_date_to'";
			}
			if ($r_from_date != '' && $r_date_to != '') {
				$condtion .= " AND date(`task_date`) >= '$r_from_date'  AND date(`task_date`) <= '$r_date_to'";
			}
		}
		if ($user != '') {
			$condtion .= " AND `user_id` = '" . $user . "'";
		}
		$qry = $this->db->query("SELECT * FROM `task_log` WHERE  task_flag = '1' $condtion  ORDER BY task_date desc");
		//echo $this->db->last_query();
		return $qry->result_array();

	}

	public function geterrorflagdata($task_log_id){
		$qry = $this->db->query("SELECT TL.*,
								TA.client_id,
								TA.project_name,
								TA.summary,
								TA.type,
								TA.billing_type
								FROM `task_log` AS TL
								left join  `task_allocation` TA ON TA.task_no = TL.task_no AND TA.task_id = TL.task_id
								WHERE  task_flag = '1' AND `task_log_id` = $task_log_id");
		return $qry->row();
	}


	public function update_task_errorflag_data($task_log_id){
		$begin_date  = $this->input->post('begin_date');
		$end_date    = $this->input->post('end_date');
		$begin_time  = $this->input->post('begin_time');
		$end_time    = $this->input->post('end_time');
		// if($begin_time  < ('1:00:00')){
		// 	$endtime = new DateTime($end_time );
		// 	$endtime->sub(new DateInterval('PT45M'));  
		// 	$end_time =  $endtime->format('H:i:s');
		// }
		// else{
		// 	$end_time  = $end_time;
		// }
		$task_date = date('Y-m-d', strtotime($begin_date)).' '.$begin_time;
		$update_date =  date('Y-m-d', strtotime($end_date)).' '.$end_time;
		$starttimestamp = strtotime($task_date);
		$endtimestamp = strtotime($update_date);
		$timediff = abs($endtimestamp - $starttimestamp);
		$timediff = abs($endtimestamp - $starttimestamp);
		$hours = floor($timediff / 3600);
		$minutes = floor(($timediff % 3600) / 60);
		$seconds = $timediff % 60;
		$task_duration = sprintf('%02d:%02d:%02d', $hours, $minutes, $seconds);
 		$qry = $this->db->query("UPDATE `task_log` SET  `task_date` ='$task_date',`task_duration` ='$task_duration' , `task_flag` = '0'  WHERE `task_log_id` = '".$task_log_id."' ");
		if($qry){
			return true;
		}
		else{
			return false;
		}
	}

	public function getstaffWorkallocation(){
		$r_from_date = date("Y-m-d", strtotime($this->input->post('report_date_from')));
		$r_date_to =  date("Y-m-d", strtotime($this->input->post('report_date_to')));
		$user = $this->input->post('userid');
		$client_id = $this->input->post('client_id');
		$condtion = "" ;

		if($r_from_date != '' && $r_date_to == ''){
			$condtion .= " AND date(`task_date`) >= '$r_from_date'";
		}
		if ($r_date_to != '' && $r_from_date == '') {
			$condtion .= " AND date(`task_date`) <= '$r_date_to'";
		}
		if ($r_from_date != '' && $r_date_to != '') {
			$condtion .= " AND date(`task_date`) >= '$r_from_date'  AND date(`task_date`) <= '$r_date_to'";
		}
		if ($user != '') {
			$condtion.= " AND `user_id` = '" . $user . "'";
		}
		if ($client_id != '') {
			$condtion .= " AND `client_id` = '".$client_id."'";
		}
		//$qry = $this->db->query("SELECT TA.*, TL.task_date FROM task_allocation AS TA INNER JOIN `task_log` AS TL ON TL.task_no = TA.task_no AND TL.task_id = TA.task_id   WHERE TA.task_id IS NOT NULL  $condtion ");
		$qry = $this->db->query("SELECT TA.*, 
										TL.task_date,TL.user_id FROM task_allocation AS TA 
										INNER JOIN `task_log` AS TL ON TL.task_no = TA.task_no AND TL.task_id = TA.task_id  
										WHERE TA.task_id IS NOT NULL  $condtion ");
		//echo $this->db->last_query();
 		return $qry->result_array();
	}

	public function gettaskdataRow($task_id){
		$qry = $this->db->query("SELECT * FROM task_allocation WHERE task_id = '".$task_id."'");
		if($qry->num_rows()>0){
			return $qry->row();
		}
	}

	public function insert_task_log_data(){
		$task_id = $this->input->post('task_id');
		$task_no = $this->input->post('task_no');
		$user_id = $this->input->post('user_id');
		$begin_date  = $this->input->post('begin_date');
		$end_date    = $this->input->post('end_date');
		$begin_time  = $this->input->post('begin_time');
		$end_time    = $this->input->post('end_time');
		$task_date = date('Y-m-d', strtotime($begin_date)).' '.$begin_time;
		$update_date =  date('Y-m-d', strtotime($end_date)).' '.$end_time;
		$starttimestamp = strtotime($task_date);
		$endtimestamp = strtotime($update_date);
		$timediff = abs($endtimestamp - $starttimestamp);
		$hours = floor($timediff / 3600);
		$minutes = floor(($timediff % 3600) / 60);
		$seconds = $timediff % 60;
		$task_duration = sprintf('%02d:%02d:%02d', $hours, $minutes, $seconds);
		$qry = $this->db->query("INSERT INTO `task_log`(
			`task_id`,
			`task_no`,
			`task_date`,
			`task_status`,
			`end_task`,
			`task_duration`,
			`user_id`)
			 VALUES (
			'".$task_id."',
			'".$task_no."',
			'".$task_date."',
			'dev_begin',
			'".$update_date."',
			'".$task_duration."',
			'".$user_id."')");
		return true;
		if($qry){
			return true;
		}
		else{
			return false;
		}
	}
}
?>
