<?php
 if (!defined('BASEPATH')) exit('No direct script access allowed');
 
 
class Furniture_quotation_client_project extends CI_Controller {

	public function __construct()
	{
		parent::__construct();// you have missed this line.\
		if($this->session->userdata('user_logged_in') != true)
		{
			$this->session->set_flashdata('response','<div class="alert alert-error">Unauthorised access. Login required.</div>');
			redirect('Login');
		}
		$this->load->model('EnquiryModel');
	}
	
	
	function index($quotation_id=NULL) {
			
		if($quotation_id== NULL) {
			$this->session->set_userdata('quotation_mode','new');
			$data['quotation_mode']='new';
			$data['furniture_quotation_id']=$quotation_id;
		} else {
			
			// Edit Quotation
			if(!($this->furniture_quotation_model->check_privilege($quotation_id))) {
				//exit();
					$this->session->set_flashdata('response','Sorry! You don\'t have the privilege to modify this quotation.');
					redirect('furniture/furniture_quotations');
			}
			
			
			// Good to go.
			
			$where=array('furniture_quotation.id' => $quotation_id);
						
			$records=$this->crud_model->get_view_furniture_quotations_client_project_users($where);
			
			if($records[0]['status']!="Sales"){

			/*if($this->session->userdata('is_estimator')==1 && $records[0]['estimator_id']==NULL){
				$wherenbx = array('id'	=> $quotation_id);		
				$data_quonbx['estimator_id'] = $this->session->userdata('user_id');									
				$rr_quo = $this->crud_model->update('furniture_quotation',$data_quonbx,$wherenbx);
				redirect('furniture/Furnitures/index/'.$quotation_id);
			} else if($this->session->userdata('is_approver')==1 && $records[0]['approver_id']==NULL){
				$wherenbx2 = array('id'	=> $quotation_id);		
				$data_quonbx2['approver_id'] = $this->session->userdata('user_id');									
				$rr_quo = $this->crud_model->update('furniture_quotation',$data_quonbx2,$wherenbx2);
				//redirect('furniture/Furnitures/index/'.$quotation_id);
			} else if( $this->session->userdata('user_id')!=$records[0]['estimator_id'] && $this->session->userdata('user_id')!=$records[0]['approver_id'] && $records[0]['estimator_id']!=NULL) {
				$this->session->set_flashdata('response','Sorry! The quotation already Picked.');
				redirect('furniture/furniture_quotations');
			} */
         }
			
			$quotation_status = $records[0]['quotation_status'];
			
						
			if( $quotation_status == "Open" ) {
				$this->session->set_userdata('quotation_mode','edit');
			} else {
				$this->session->set_userdata('quotation_mode','draft');
			}

			$this->session->set_userdata('furniture_quotation_id',$quotation_id);
						
			$data['quotation_mode']='edit';
			$data['furniture_quotation_id']=$quotation_id;
						
			$data["quotation_divisionid"] = $records[0]["quotation_divisionid"];
			$data["division_name"] = $records[0]["division_name"];
			$data["quotation_vat_percentage"] = $records[0]["quotation_vat_percentage"];
			
			$data["quotation_currencyid"] = $records[0]["quotation_currencyid"];
			$data["quotation_number_full"]=$records[0]["division_code"] . "-". $records[0]["quotation_number"] . "-" . $records[0]["quotation_revisionnumber"];
			
			
			$data["client_name"] = $records[0]["client_name"];
			$data["client_address"] = $records[0]["client_address"];
			$data["client_country"] = $records[0]["client_country"];
			$data["client_telephone1"] = $records[0]["client_telephone1"];
			$data["client_telephone2"] = $records[0]["client_telephone2"];
			$data["client_fax"] = $records[0]["client_fax"];
			$data["client_email"] = $records[0]["client_email"];			
			$data["client_id"] = $records[0]["client_id"];
			$data["contact_person"] = $records[0]["contact_person"];
			
			$data["project_name"] = $records[0]["project_name"];
			$data["project_location"] = $records[0]["project_location"];
			$data["project_remarks"] = $records[0]["project_remarks"];	
		    $data["project_contact_person_email"] = $records[0]["project_contact_person_email"];
			$data["project_contact_person_number"] = $records[0]["project_contact_person_number"];	
			$data["tax_name"] = $records[0]["tax_name"];
			$data["tax_no"] = $records[0]["tax_no"];
			$data["contact_id"] = $records[0]["contact_id"];
			$data["Contact_Name"] = $records[0]["Contact_Name"];
			$data["Contact_Tel"] = $records[0]["Contact_Tel"];
			$data["Contact_Email"] = $records[0]["Contact_Email"];
			$nbquotation_number=$records[0]["division_code"] . "-". $records[0]["quotation_number"];

			
			$enquiry_records=$this->EnquiryModel->dataRow($quotation_id);

			if($enquiry_records != false){
				$data['enquiry_number']		= $enquiry_records[0]['enquiry_number'];
				$data['client_name']		= $enquiry_records[0]['client_name'];
				$data['email']				= $enquiry_records[0]['email'];
				$data['client_id']			= $enquiry_records[0]['client_id'];
				$data['client_code']		= $enquiry_records[0]['client_code'];
				$data['phone']				= $enquiry_records[0]['phone'];
				$data['email']				= $enquiry_records[0]['email'];
				$data['client_address']		= $enquiry_records[0]['client_address'];
				$data['contact_person']		= $enquiry_records[0]['contact_person'];
				$data['tax_name']			= $enquiry_records[0]['tax_name'];
				$data['tax_no']				= $enquiry_records[0]['tax_no'];
				$data['tax_perce']			= $enquiry_records[0]['tax_perce'];
				$data['contact_person']		= $enquiry_records[0]['contact_person'];
			} else {
				$data['enquiry_number']		= NULL;
				$data['client_name']		= NULL;
				$data['email']				= NULL;
				$data['client_id']			= NULL;
				$data['client_code']		= NULL;
				$data['phone']				= NULL;
				$data['email']				= NULL;
				$data['client_address']		= NULL;
				$data['contact_person']		= NULL;
				$data['tax_name']			= NULL;
				$data['tax_no']				= NULL;
				$data['tax_perce']			= NULL;
				$data['contact_person']		= NULL;
			}
						
		}
		
		$like=null;		

		$list = $this->crud_model->get_list('division_id','division_name','company_division',array('select'=>' - Select - '));
		$data['division_list'] = $list;

		$list2 = $this->crud_model->get_list('Contact_Id','Contact_Name','client_contact',array(''=>' - Select Contact Person - '),array('Client_Id'=>$records[0]["client_id"]));
		$data['client_contact_list'] = $list2;
		
		$date=date("Y-m-d");
		$data['vat_applicable']=$this->furniture_quotation_model->vat_applicable($date);

		$this->load->view('templates/header');
		$this->load->view('furniture/quotations/furniture_quotation_client_project/client_project_view',$data);
		$this->load->view('templates/footer');
	}
	
	
	function search_client() {
	
		$search_name = trim($this->input->post('search_name'));
		$search_mob = trim($this->input->post('search_mob'));
		
		
		$or_where=array();
		$like=null;
		if($search_mob !='') {
			$or_where=array('client_telephone1'=>$search_mob,
							'client_telephone2'=>$search_mob);
		
		}	

		if($search_name!=''){
			$like=array('client_name'=>$search_name);
		}
		
		$records['client_list']=$this->crud_model->get('new_client_master',array(), null,null,null,null,$like, $or_where);
						
		if($records['client_list'] == false ){
			echo 0;
		} else {
			$records=html_escape($records);
			$this->load->view('furniture/quotations/furniture_quotation_client_project/search_result', $records);
			
		}
		
	}
	
	
	function search_client2() {
		
		$search_name = trim($this->input->post('search_name'));
		$search_mob = trim($this->input->post('search_mob'));
		$or_where=array();
		$like=null;
		if($search_mob !='') {
			$or_where=array('client_telephone1'=>$search_mob,
							'client_telephone2'=>$search_mob);
		
		}	

		if($search_name!=''){
			$like=array('client_name'=>$search_name);
		}
		
		$records['client_list']=$this->crud_model->get('new_client_master',array(), null,null,null,null,$like, $or_where);
		$html='';				
		if($records['client_list'] == false ){
			$html.='<li style="color:red;" class="no_result_button" > No Results Found </li>';
			echo $html;
		} else {
			//$records=html_escape($records);
			
			$java_script='<script type="text/javascript" >var client_list = new Array();';
			foreach($records['client_list'] as $index=>$client_entry) {
				$java_script.="client_list[" . $index . "]=new Array();";

				$java_script.="client_list[" . $index . "][0]=" . $client_entry['client_id'] . ";";
				$java_script.="client_list[" . $index . "][1]='" .  preg_replace("/#?[a-z0-9]+;/i","",$client_entry['client_name']) . "';";
				$java_script.="client_list[" . $index . "][2]='" . $client_entry['client_address'] . "';";
				$java_script.="client_list[" . $index . "][3]='" . $client_entry['client_country'] . "';";
				$java_script.="client_list[" . $index . "][4]='" . $client_entry['client_telephone1'] . "';";
				$java_script.="client_list[" . $index . "][5]='" . $client_entry['client_telephone2'] . "';";
				$java_script.="client_list[" . $index . "][6]='" . $client_entry['client_fax'] . "';";
				$java_script.="client_list[" . $index . "][7]='" . $client_entry['client_email'] . "';";
				$java_script.="client_list[" . $index . "][8]='" . preg_replace("/#?[a-z0-9]+;/i","",$client_entry['contact_person']) . "';";
				
				$html.='<li  value="'.$client_entry['client_id'].'" class="client_buttonxxxxx" ><input type="hidden" class="client_name" value="'.  preg_replace("/#?[a-z0-9]+;/i","",$client_entry['client_name']) .'" /><input type="hidden" class="client_address" value="'.$client_entry['client_address'].'" /><input type="hidden" class="client_country" value="'.$client_entry['client_country'].'" /><input type="hidden" class="client_telephone1" value="'.$client_entry['client_telephone1'].'" /><input type="hidden" class="client_telephone2" value="'.$client_entry['client_telephone2'].'" /><input type="hidden" class="client_fax" value="'.$client_entry['client_fax'].'" /><input type="hidden" class="client_email" value="'.$client_entry['client_email'].'" /><input type="hidden" class="contact_person" value="'.preg_replace("/#?[a-z0-9]+;/i","",$client_entry['contact_person']).'" />'. $client_entry['client_name'] . '</li>';
			
			}
			
			$java_script.='</script>';
			//$this->load->view('furniture/quotations/furniture_quotation_client_project/search_result', $records);
			//print ;
			echo $html;
		}	
	}
	
	function existing_search_client() {
	
		$client_email_id = $this->input->post('client_email_id');
		$client_phone_number1 = $this->input->post('client_phone_number1');
		$client_phone_number2 = $this->input->post('client_phone_number2');
		//$or_where=array();
	    //$where=array('client_email'=>$client_email_id);
		$or_where=array('client_email'=>$client_email_id,
							'client_telephone1'=>$client_phone_number1,'client_telephone2'=>$client_phone_number2);
		//$records['client_list']=$this->crud_model->get('new_client_master',array(), null,null,null,null,null, $or_where);
		// OR `client_telephone1`='$client_phone_number1' OR (`client_telephone2`='$client_phone_number2' AND `client_telephone2`!='')
		$up_data = $this->db->query("SELECT * FROM `new_client_master` WHERE (`client_email`='$client_email_id' AND `client_email`!='')");
		
		$records['client_list'] = $up_data->result_array();
						
		if($records['client_list'] == false ){
			echo 0;
		} else {
			$records=html_escape($records);
			$this->load->view('furniture/quotations/furniture_quotation_client_project/search_result', $records);
			
		}
		
	}
	
	public function getContactDetails() {
      $no = $this->input->post('no');
      $jobData = $this->EnquiryModel->getContactData($no);
      if($jobData!=false){
        echo json_encode($jobData);
      }else{
        echo 0;
      }
    }

	public function addContactPerson(){
		
		if ($this->input->post('client_id')!='' && $this->input->post('client_Contact_Name')!='' && $this->input->post('client_Contact_Tel')!='' && $this->input->post('client_id')!='undefined' && $this->input->post('client_Contact_Name')!='undefined' && $this->input->post('client_Contact_Tel')!='undefined'){
				
				$client_id	=	$this->input->post('client_id');
				$client_Contact_Name	=	$this->input->post('client_Contact_Name');
				$client_Contact_Tel	=	$this->input->post('client_Contact_Tel');
				$client_Contact_Email	=	$this->input->post('client_Contact_Email');
				$client_Contact_designation	=	$this->input->post('client_Contact_designation');
				$user_id	=	$this->session->userdata('user_id');
				$Creation_date=date("Y-m-d");
				$client_Contact_Address=$this->input->post('client_Contact_Address');
				$query = $this->db->query("INSERT INTO `client_contact` (`Client_Id`,`Contact_Name`,`designation`,`Contact_Address`, `Contact_Tel`, `Contact_Email`, `Creation_date`, `Created_UserId`) VALUES ('$client_id','$client_Contact_Name','$client_Contact_designation','$client_Contact_Address','$client_Contact_Tel','$client_Contact_Email','$Creation_date','$user_id') ");
				if ($query){
					$c_id	=	$this->db->insert_id();
					$data   =   json_encode(array('1',$c_id));
					echo $data;
				} else {
					$c_id	=	0;
					$data   =   json_encode(array('0',$c_id));
					echo $data;
				}
			
		} else {
			$c_id	=	0;
			$data   =   json_encode(array('0',$c_id));
			echo $data;
		
		}
	}
	
	function update($quotation_mode,$furniture_quotation_id=0) {
		if(!($this->furniture_quotation_model->check_privilege($furniture_quotation_id))) {
					$this->session->set_flashdata('response',
						'<div class="alert alert-error">Sorry! You don\'t have the privilege to modify this quotation.</div>');
					redirect('furniture/furniture_quotations');
		}
		$this->form_validation->set_rules('client_contact', 'Contact Person', 'required');
		$this->form_validation->set_rules('project_name', 'Project Name', 'required');
		//$this->form_validation->set_rules('project_remarks', 'Project More details', 'max_length[200]');
		
		$client_contact = $this->input->post('client_contact');
		$project_name = $this->input->post('project_name');
		$project_remarks = $this->input->post('project_remarks'); 
		
		if ($this->form_validation->run() == false)	{
			$this->session->set_flashdata('response',''.validation_errors().'');
			redirect('furniture/Furniture_quotation_client_project/index/'.$furniture_quotation_id);			
			
		} else {
		
			//$this->furniture_quotation_model->check_changes_cloned();
			$data=array(
				'project_name' 		 => $this->input->post('project_name'),
				'contact_id' 		 => $this->input->post('client_contact'),
				'quotation_vat_percentage' 		 => $this->input->post('tax_perce'),
				'project_remarks' 	 => $this->input->post('project_remarks'),
				'last_modified_by' 	 => $this->session->userdata('user_id'),
				'last_modified_date' => date('Y-m-d h:m:s') 
			);
			
			$where = array('id' => $furniture_quotation_id);
			$this->crud_model->update('furniture_quotation',$data,$where);
			
			$this->session->set_flashdata('response','The quotation has been updated.',':old:');
			redirect('furniture/Furnitures/index/'.$furniture_quotation_id);
			
		}
	} // Function update

	function updatexxxx($quotation_mode,$furniture_quotation_id=0) {
		if($quotation_mode != false && $quotation_mode != 'new') {
		
			if(!($this->furniture_quotation_model->check_privilege($furniture_quotation_id))) {
					$this->session->set_flashdata('response',
						'<div class="alert alert-error">Sorry! You don\'t have the privilege to modify this quotation.</div>');
					redirect('furniture/furniture_quotations');
			}
		}		
		$quotation_mode =$quotation_mode;
		
		$this->form_validation->set_rules('client_name', 'Client Name', 'required|max_length[100]');
		$this->form_validation->set_rules('client_address', 'Client Address', 'required|max_length[200]');
		$this->form_validation->set_rules('client_phone_number1', 'Telephone 1', 'required|numeric|max_length[20]');
		$this->form_validation->set_rules('client_phone_number2', 'Telephone 2', 'numeric|max_length[20]');
		$this->form_validation->set_rules('client_fax_number', 'Fax', 'numeric|max_length[20]');
		//$this->form_validation->set_rules('client_email_id', 'Client Email ID', 'required|valid_email|max_length[100]');
		$this->form_validation->set_rules('contact_person', 'Contact Person', 'required|max_length[100]');
		$this->form_validation->set_rules('project_name', 'Project Name', 'required');
		$this->form_validation->set_rules('project_more_details', 'Project More details', 'max_length[200]');
		if($quotation_mode == 'new') {
			//$this->form_validation->set_rules('client_email_id', 'Email', '|is_unique[new_client_master.client_email]');
		}
		/*$this->db->select('*');
		$this->db->from('new_client_master');
		$this->db->where('client_telephone1', $this->input->post('client_phone_number1'));
		$this->db->or_where('client_telephone2', $this->input->post('c1lient_phone_number2')); 
		$this->db->or_where('client_email', $this->input->post('client_email_id'));*/
		
		$client_phone_number1 = $this->input->post('client_phone_number1');
		$client_phone_number2 = $this->input->post('client_phone_number2');
		$client_email_id = $this->input->post('client_email_id'); 
		//OR `client_telephone1`='$client_phone_number1' OR (`client_telephone2`='$client_phone_number2' AND `client_telephone2`!='')
		$up_data = $this->db->query("SELECT * FROM `new_client_master` WHERE (`client_email`='$client_email_id' AND `client_email`!='') ");
		
		if ($this->form_validation->run() == false)	{
			// false section
			$this->session->set_flashdata('response',''.validation_errors().'');
			//echo validation_errors();
			
			
			if($quotation_mode == 'new') {
				redirect('furniture/Furniture_quotation_client_project');
			} else {
				$curr_quotation_id = $this->session->userdata('furniture_quotation_id');
				redirect('furniture/Furniture_quotation_client_project/index/'.$curr_quotation_id);			
			}
			//return;
		}
		/*else if($_POST['client'] == "new_client" && $up_data->num_rows() > 0){
			echo "Duplication in Email ID not allowed";
			return;
		}*/ 
		else{
		
			$quotation_mode=$quotation_mode;
			
			//Updating Client Master
			$client_selection = $this->input->post('client');
			
			$data=array(
			  'client_name' => $this->input->post('client_name'),
			  'client_address' => $this->input->post('client_address'),
			  'tax_name' => $this->input->post('tax_name'),
			  'tax_no' => $this->input->post('tax_no'),
			  'client_country' => 0,
			  'client_telephone1' => $this->input->post('client_phone_number1'),
			  'client_telephone2' => $this->input->post('client_phone_number2'),
			  'client_fax' => $this->input->post('client_fax_number'),
			  'client_email' => $this->input->post('client_email_id'),
			  'contact_person' => $this->input->post('contact_person')
			);
			
				
			if($client_selection=="search") {
				echo "<p>Missing Client Details</p>";
				return;
			} elseif($client_selection=="new_client") {
				
				$new_client_id=$this->crud_model->insert('new_client_master',$data);
				
			} else {
				$where = array('client_id' => $client_selection);
				$this->crud_model->update('new_client_master',$data,$where);
				$new_client_id=$client_selection;
			}
			
				
			if($quotation_mode == 'new') {
		
				$this->furniture_quotation_model->set_quotation_id($this->input->post('textfield2'));
				$data=array(
				'client_id' => $new_client_id,
				'project_name' => $this->input->post('project_name'),
				'quotation_revisionnumber' => 0,
				'project_location' => $this->input->post('project_location'),
				'project_remarks' => $this->input->post('project_more_details'),
				'quotation_divisionid' => $this->input->post('textfield2'),
				'quotation_currencyid ' => $this->input->post('currency'),
				'project_contact_person_email' => $this->input->post('project_contact_person_email'),
				'project_contact_person_number ' => $this->input->post('project_contact_person_number'),
				'quotation_vat_percentage' => $this->input->post('quotation_vat_percentage'),
				'quotation_status' => "Draft",
				'last_modified_by' => $this->session->userdata('user_id'),
				'last_modified_date' => date('Y-m-d h:m:s'));
			} else {
			
				$this->furniture_quotation_model->check_changes_cloned();
				$data=array(
				'client_id' => $new_client_id,
				'project_name' => $this->input->post('project_name'),
				'project_location' => $this->input->post('project_location'),
				'project_remarks' => $this->input->post('project_more_details'),
				'quotation_currencyid ' => $this->input->post('currency'),
				'project_contact_person_email' => $this->input->post('project_contact_person_email'),
				'project_contact_person_number ' => $this->input->post('project_contact_person_number'),
				'last_modified_by' => $this->session->userdata('user_id'),
				'last_modified_date' => date('Y-m-d h:m:s') );
	
			}
			$this->session->set_userdata('division_val_id',$this->input->post('textfield2'));
			$cookie_division_val = array(
					'name'   => 'division_val_id',
					'value'  => $this->input->post('textfield2'),
					'expire' => 60*60*24*60
				);
			$this->input->set_cookie($cookie_division_val);
			$curr_quotation_id = $this->session->userdata('furniture_quotation_id');
			$where = array('id' => $curr_quotation_id);
			$this->crud_model->update('furniture_quotation',$data,$where);
				
			$cookie_currency = array(
				'name'   => 'currency_value',
				'value'  => $this->input->post('currency'),
				'expire' => 60*60*24*60
			);
			$this->input->set_cookie($cookie_currency);
			
			if($this->input->post('division') != false) {
				
				$cookie_division = array(
					'name'   => 'division_value',
					'value'  => $this->input->post('division'),
					'expire' => 60*60*24*60
				);
				$this->input->set_cookie($cookie_division);
				
			}
					
			
			if($quotation_mode == 'new') {
				$this->session->set_flashdata('response','<div class="alert alert-error">New quotation is created.</div>',':old:');
				redirect('furniture/Furnitures/index/'.$curr_quotation_id);
			} else {
				$this->session->set_flashdata('response','<div class="alert alert-error">The quotation has been updated.</div>',':old:');
				redirect('furniture/Furnitures/index/'.$furniture_quotation_id);
			}
			
			//echo '1';
		}
	}// Function update
	
} // Closing of main class
?>