<!doctype html>
<html lang="en" dir="ltr">
	<head>
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
		<!-- FAVICON -->
		<link rel="shortcut icon" type="image/x-icon" href="<?php echo base_url(); ?>/images/new/favicon-16x16.png" />

		<!-- TITLE -->
		<title><?php if(isset($headerTitle)) { echo $headerTitle; } else { echo 'Nettworksy Technologies Co WLL'; } ?></title>

		<!-- BOOTSTRAP CSS -->
		<link id="style"  href="<?php echo base_url(); ?>/admincss/plugins/bootstrap/css/bootstrap.min.css" rel="stylesheet" />

		<!-- STYLE CSS -->
		<link  href="<?php echo base_url(); ?>/admincss/css/style.css" rel="stylesheet"  />
		<link  href="<?php echo base_url(); ?>/admincss/css/progress_bar.css" rel="stylesheet" media="none" onload="if(media!=='all')media='all'"/>
		<link  href="<?php echo base_url(); ?>/admincss/plugins/datatable/css/buttons.dataTables.min.css" rel="stylesheet">
		<!-- PLUGINS CSS -->
		<link href="<?php echo base_url(); ?>/admincss/css/plugins.css" rel="stylesheet"  media="none" onload="if(media!=='all')media='all'">
		 

		<!--- FONT-ICONS CSS -->
		<link  href="<?php echo base_url(); ?>/admincss/css/icons.css" rel="stylesheet" media="none" onload="if(media!=='all')media='all'"/>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.1/moment.min.js"></script>
		<style>
			.title3 {
				font-size: 15px;
				color: #21ADE8;
				line-height: normal;
				margin-top: 0px;
				margin-right: 0px;
				margin-left: 0px;
				padding-left: 7px;
			}
			p {
				margin-block-end: 0em !important;
				margin-block-start: 0em !important;
			}
			.richText .richText-editor{
				height:220px !important;
			}
			.my-links {
				cursor: default;
			}
			.header .message-menu-scroll {
					height: auto;
				}
			.message-menu {
				max-height: 800px !important;
			}
			.sweet-alert p{
				padding-bottom: 15px;
    			padding-top: 10px;
			}
			.sa-button-container .cancel{
				background-color: #df2243!important;
				box-shadow: 0 0 0 2px rgb(94 45 216 / 0%);
			}
			.sweet-alert .sa-icon.sa-success .sa-placeholder{
				border: 4px solid rgb(162 205 231 / 77%);
			}
			.sweet-alert h2{
				margin-top: 10px;
			}
			.richText-editor ul{
				list-style-type: inherit;
			}
			.richText-editor b, strong {
				font-weight: bolder;
			}	
			@media screen and (max-height: 932px){
				.message-menu{
					height:350px !important;
				}
			}
		</style>
	</head>

	<body class="app sidebar-mini light-mode">

		<!-- GLOBAL-LOADER -->
		<div id="global-loader">
			<img src="<?php echo base_url(); ?>/admincss/images/loader.svg" class="loader-img" alt="Loader">
		</div>
		<!-- /GLOBAL-LOADER -->

		<div class="full_load"><div class="loader" ></div></div>

		<!-- PAGE -->
		<div class="page">
			<div class="page-main">

				<!-- APP-HEADER -->
				<div class="app-header header sticky">
					<div class="container-fluid main-container">
						<div class="d-flex align-items-center">
							<a aria-label="Hide Sidebar" class="app-sidebar__toggle" data-bs-toggle="sidebar" href="javascript:void(0)"></a>
							<!-- sidebar-toggle-->
							<a class="logo-horizontal " href="<?php echo site_url('dashboard/home'); ?>">
								<!-- <img src="<?php echo base_url(); ?>admincss/images/brand/q-pro-logo.jpg" class="header-brand-img desktop-logo" alt="logo">
								<img src="<?php echo base_url(); ?>admincss/images/brand/q-pro-logo1.jpg" class="header-brand-img light-logo1"alt="logo"> -->
							</a>
							<div class="main-header-center ms-3 d-none d-lg-block">Welcome : <span class="title3"><?php echo ucfirst($this->session->userdata('user_name'));?></span> </div>
							<!-- LOGO -->
							<!--<div class="main-header-center ms-3 d-none d-lg-block">
								<input type="text" class="form-control" placeholder="Search for results..." autocomplete="off">
								<button class="btn px-0 pt-2"><i class="fe fe-search" aria-hidden="true"></i></button>
							</div>-->
							<div class="selectdivision" style="padding-left: 10px;">
							  	<select class="form-control form-select select2" name="select_division" id="select_division" data-placeholder="Select Division">
									<option value="">Choose Division</option>
									<?php 
										if(isset($division_val_id)!=''){
											$h_division_id = $division_val_id; 
										}else {
											$xxx='slll';
											if(get_cookie('division_val_id')!=false){ 
												$h_division_id =get_cookie('division_val_id'); 
											} else { 
												$h_division_id=NULL; 
											}
										}
										$dision_list = $this->crud_model->getuserDivision();
										foreach($dision_list as $rec){
											echo '<option value="' . $rec['division_id'] . '"'.(@$h_division_id == $rec['division_id'] ? 'selected' : '') .' >' . $rec['division_name'] . ' </option>';
										}
									?>
								</select> 
							</div>
							<div class="d-flex order-lg-2 ms-auto header-right-icons">
								<div class="dropdown d-none">
									<a href="javascript:void(0)" class="nav-link icon" data-bs-toggle="dropdown">
										<i class="fe fe-search"></i>
									</a>
									<div class="dropdown-menu header-search dropdown-menu-start">
										<div class="input-group w-100 p-2">
											<input type="text" class="form-control" placeholder="Search....">
											<div class="btn btn-primary">
												<i class="fe fe-search" aria-hidden="true"></i>
											</div>
										</div>
									</div>
								</div>
								<!-- SEARCH -->
								<!--<button class="navbar-toggler navresponsive-toggler d-lg-none ms-auto" type="button"
									data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent-4"
									aria-controls="navbarSupportedContent-4" aria-expanded="false"
									aria-label="Toggle navigation">
									<span class="navbar-toggler-icon fe fe-more-vertical"></span>
								</button>-->
								<div class="navbar navbar-collapse responsive-navbar p-0">
									<!-- <div class=" collapse navbar-collapse" id="navbarSupportedContent-4"> -->
										<div class="d-flex order-lg-2">
											<!--<div class="dropdown d-lg-none d-flex">
												<a href="javascript:void(0)" class="nav-link icon" data-bs-toggle="dropdown">
													<i class="fe fe-search"></i>
												</a>
												<div class="dropdown-menu header-search dropdown-menu-start">
													<div class="input-group w-100 p-2">
														<input type="text" class="form-control" placeholder="Search....">
														<div class="btn btn-primary">
															<i class="fa fa-search" aria-hidden="true"></i>
														</div>
													</div>
												</div>
											</div>-->
											<!--<div class="d-flex country">
												<a class="nav-link icon text-center" data-bs-target="#country-selector"
													data-bs-toggle="modal">
													<img src="<?php echo base_url(); ?>/admincss/images/flags/us_flag.jpg"></span>
												</a>
											</div>-->
											<!-- COUNTRY -->
											<?php
										//	$is_developer = $this->session->userdata('is_developer');
									  //'.site_url("Developerdashboard/Updatetaskduration").'
									  //<a class="nav-link icon theme-layout nav-link-bg no_task "  href="#"><span class="dark-layout" title="Task Off" ><i class="fe fe-eye-off" style="color:#b73333 !important;"></i></span></a>
											//if($is_developer == 1) {												
													$icon = (@$isbegin == true ? '<a class="nav-link icon theme-layout nav-link-bg task-off " href="#">
													<span class="dark-layout" title="Task SignOff" ><i class="fe fe-eye" style="color:#43b143 !important;"></i></span></a>' : '');
											?>
											<div class="d-flex">
											   <?= $icon; ?>
											</div>
											<?php //} ?>
											<?php 
												$user_id = $this->session->userdata('user_id');
												$groups_query = $this->db->query("SELECT c.group_by as id,cg.name as group_name FROM `permission` p inner join controllers c on c.controller_name=p.controller inner join controller_group cg on cg.id=c.group_by WHERE p.`user_id` = '".$user_id."' and p.is_quick_menu='1' group by c.group_by order by c.group_by");
												if($groups_query!=false){
											?>
											<div class="dropdown  d-flex message">
												<a class="icon btn btn-sm btn-outline-success" data-bs-toggle="dropdown" style="width:150px;text-align:left;font-size:15px;">
												<b>Quick Menu</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i class="fe fe-align-right" style="font-size:15px;" ></i><span class="pulse-danger"></span>
												</a>
												<div class="dropdown-menu dropdown-menu-end dropdown-menu-arrow">
													<!-- <div class="drop-heading border-bottom">
														<div class="d-flex">
															<h6 class="mt-1 mb-0 fs-16 fw-semibold text-dark"><b>Quick Menu</b></h6>
														</div>
													</div> -->
													<div class="message-menu message-menu-scroll" style="min-height: auto;">
													<?php 
														foreach($groups_query->result() as $row) {
															$group_by=$row->id;
															$group_name=$row->group_name;
															if($group_by==3){
																$group_icon='fa fa-bar-chart';
															} else if($group_by==2){ 
																$group_icon='fe fe-cpu';
															} else {
																$group_icon='ti-receipt';
															}
															echo '<a class="dropdown-item d-flex my-links" href="javascript:void(0)" style="padding: 0.5rem !important;" >
																	<div class="wd-90p">
																		<div class="d-flex">
																			<h5 class="mb-1" style="font-size: 0.8rem;"  &nbsp;><i class="'.$group_icon.'" style="color: #45aaf2 !important;"></i> &nbsp; '.$group_name.'</h5>
																		</div>
																	</div>
																</a>';
																
																$quick_menu_array = $this->db->query("SELECT p.*,c.field_name,c.view_url,c.create_url,c.icon_url,c.controller_name FROM `permission` p inner join controllers c on c.controller_name=p.controller WHERE p.`user_id` = '$user_id' and c.group_by = '".$group_by."' and p.is_quick_menu='1' order by p.sort_by asc");
																$quick_menus = $quick_menu_array->result_array();
																if($quick_menus!=false){ ?>
																	<?php foreach($quick_menus as $quick_menu){ 
																		$quick_menu_view_url=$quick_menu['view_url'];
																		$quick_menu_create_url=$quick_menu['create_url'];
																		$quick_menu_can_add=$quick_menu['add'];
																		$quick_menu_actual='';
																		if ($quick_menu_can_add==='yes') {
																			if($quick_menu_create_url==='' OR $quick_menu_create_url==null OR $quick_menu_create_url==0) {
																				$quick_menu_actual=$quick_menu_view_url;	
																			} else {
																				$quick_menu_actual=$quick_menu_create_url;	
																			}
																		} else {
																			$quick_menu_actual=$quick_menu_view_url;	
																		}
																		if($quick_menu['controller_name']==='Quick_menu'){
																			$quick_menu_actual=$quick_menu_actual.'/'.$user_id.'/1';
																		}
																		?>
																		<a class="dropdown-item d-flex" href="<?php echo site_url($quick_menu_actual);?>" style="padding: 0.5rem !important;" >
																			<div class="wd-90p">
																				<div class="d-flex">
																					<h5 class="mb-1" style="font-size: 0.8rem;padding-left:1.5em !important;" ><i class="<?php if($quick_menu['icon_url']!='' && $quick_menu['icon_url']!=null){ echo $quick_menu['icon_url']; } else { if($quick_menu['group_id']==1 Or $quick_menu['group_id']==2){ echo 'fe fe-plus'; } else if($quick_menu['group_id']==3) { echo 'ti-bar-chart-alt'; } } ?>" style="color: #45aaf2 !important;"></i> &nbsp; <?php echo $quick_menu['field_name']; ?></h5>
																				</div>
																			</div>
																		</a>
																	<?php } 
																}
															}
														}
													?>
													</div>
													<div class="dropdown-divider m-0"></div>
												</div>
											</div> 

											<div class="d-flex">
												<a class="nav-link icon theme-layout nav-link-bg layout-setting">
													 
													<span class="dark-layout"><i class="fe fe-moon"></i></span>
													<span class="light-layout"><i class="fe fe-sun"></i></span>
												</a>
											</div>
											<!-- Theme-Layout -->
										<!--	<div class="dropdown  d-flex shopping-cart">
												<a class="nav-link icon text-center" data-bs-toggle="dropdown">
													<i class="fe fe-shopping-cart"></i><span class="badge bg-secondary header-badge">4</span>
												</a>
												<div class="dropdown-menu dropdown-menu-end dropdown-menu-arrow">
													<div class="drop-heading border-bottom">
														<div class="d-flex">
															<h6 class="mt-1 mb-0 fs-16 fw-semibold text-dark">My Shopping Cart</h6>
															<div class="ms-auto">
																<span class="badge bg-danger-transparent header-badge text-danger fs-14">Hurry Up!</span>
															</div>
														</div>
													</div>
													<div class="header-dropdown-list shopping-list">
														<div class="dropdown-item d-flex p-4">
															<a href="cart.html"></a>
															<span
																class="avatar avatar-xl br-5 me-3 align-self-center cover-image"
																data-bs-image-src="<?php echo base_url(); ?>/admincss/images/pngs/4.jpg"></span>
															<div class="wd-50p">
																<h6 class="mb-1">Flower Pot for Home Decor</h6>
																<span>Status: <span class="text-success">In Stock</span></span>
																<p class="fs-13 text-muted mb-0">Quantity: 01</p>
															</div>
															<div class="ms-auto text-end d-flex fs-16">
																<span class="fs-16 text-dark d-none d-sm-block px-4">
																	$438
																</span>
																<a href="javascript:void(0)" class="fs-16 btn p-0 cart-trash">
																	<i class="fe fe-trash-2 border text-danger brround d-block p-2"></i>
																</a>
															</div>
														</div>
														<div class="dropdown-item d-flex p-4">
															<a href="cart.html"></a>
															<span
																class="avatar avatar-xl br-5 me-3 align-self-center cover-image"
																data-bs-image-src="<?php echo base_url(); ?>/admincss/images/pngs/6.jpg"></span>
															<div class="wd-50p">
																<h6 class="mb-1">Black Digital Camera</h6>
																<span>Status: <span class="text-danger">Out Stock</span></span>
																<p class="fs-13 text-muted mb-0">Quantity: 06</p>
															</div>
															<div class="ms-auto text-end d-flex">
																<span class="fs-16 text-dark d-none d-sm-block px-4">
																	$867
																</span>
																<a href="javascript:void(0)" class="fs-16 btn p-0 cart-trash">
																	<i class="fe fe-trash-2 border text-danger brround d-block p-2"></i>
																</a>
															</div>
														</div>
														<div class="dropdown-item d-flex p-4">
															<a href="cart.html"></a>
															<span
																class="avatar avatar-xl br-5 me-3 align-self-center cover-image"
																data-bs-image-src="<?php echo base_url(); ?>/admincss/images/pngs/8.jpg"></span>
															<div class="wd-50p">
																<h6 class="mb-1">Stylish Rockerz 255 Ear Pods</h6>
																<span>Status: <span class="text-success">In Stock</span></span>
																<p class="fs-13 text-muted mb-0">Quantity: 05</p>
															</div>
															<div class="ms-auto text-end d-flex">
																<span class="fs-16 text-dark d-none d-sm-block px-4">
																	$323
																</span>
																<a href="javascript:void(0)" class="fs-16 btn p-0 cart-trash">
																	<i class="fe fe-trash-2 border text-danger brround d-block p-2"></i>
																</a>
															</div>
														</div>
														<div class="dropdown-item d-flex p-4">
															<a href="cart.html"></a>
															<span
																class="avatar avatar-xl br-5 me-3 align-self-center cover-image"
																data-bs-image-src="<?php echo base_url(); ?>/admincss/images/pngs/1.jpg"></span>
															<div class="wd-50p">
																<h6 class="mb-1">Women Party Wear Dress</h6>
																<span>Status: <span class="text-success">In Stock</span></span>
																<p class="fs-13 text-muted mb-0">Quantity: 05</p>
															</div>
															<div class="ms-auto text-end d-flex">
																<span class="fs-16 text-dark d-none d-sm-block px-4">
																	$867
																</span>
																<a href="javascript:void(0)" class="fs-16 btn p-0 cart-trash">
																	<i class="fe fe-trash-2 border text-danger brround d-block p-2"></i>
																</a>
															</div>
														</div>
														<div class="dropdown-item d-flex p-4">
															<a href="cart.html"></a>
															<span
																class="avatar avatar-xl br-5 me-3 align-self-center cover-image"
																data-bs-image-src="<?php echo base_url(); ?>/admincss/images/pngs/3.jpg"></span>
															<div class="wd-50p">
																<h6 class="mb-1">Running Shoes for men</h6>
																<span>Status: <span class="text-success">In Stock</span></span>
																<p class="fs-13 text-muted mb-0">Quantity: 05</p>
															</div>
															<div class="ms-auto text-end d-flex">
																<span class="fs-16 text-dark d-none d-sm-block px-4">
																	$456
																</span>
																<a href="javascript:void(0)" class="fs-16 btn p-0 cart-trash">
																	<i class="fe fe-trash-2 border text-danger brround d-block p-2"></i>
																</a>
															</div>
														</div>
													</div>
													<div class="dropdown-divider m-0"></div>
													<div class="dropdown-footer">
														<a class="btn btn-primary btn-pill w-sm btn-sm py-2" href="checkout.html"><i class="fe fe-check-circle"></i> Checkout</a>
														<span class="float-end p-2 fs-17 fw-semibold">Total: $6789</span>
													</div>
												</div>
											</div>-->
											<!-- CART -->
											<div class="dropdown d-flex">
												<a class="nav-link icon full-screen-link nav-link-bg">
													<i class="fe fe-minimize fullscreen-button"></i>
												</a>
											</div>
											<!-- FULL-SCREEN -->
										<!--	<div class="dropdown  d-flex notifications">
												<a class="nav-link icon" data-bs-toggle="dropdown"><i
														class="fe fe-bell"></i><span class=" pulse"></span>
												</a>
												<div class="dropdown-menu dropdown-menu-end dropdown-menu-arrow">
													<div class="drop-heading border-bottom">
														<div class="d-flex">
															<h6 class="mt-1 mb-0 fs-16 fw-semibold text-dark">Notifications
															</h6>
														</div>
													</div>
													<div class="notifications-menu">
														<a class="dropdown-item d-flex" href="notify-list.html">
															<div class="me-3 notifyimg  bg-primary brround box-shadow-primary">
																<i class="fe fe-mail"></i>
															</div>
															<div class="mt-1 wd-80p">
																<h5 class="notification-label mb-1">New Application received
																</h5>
																<span class="notification-subtext">3 days ago</span>
															</div>
														</a>
														<a class="dropdown-item d-flex" href="notify-list.html">
															<div class="me-3 notifyimg  bg-secondary brround box-shadow-secondary">
																<i class="fe fe-check-circle"></i>
															</div>
															<div class="mt-1 wd-80p">
																<h5 class="notification-label mb-1">Project has been
																	approved</h5>
																<span class="notification-subtext">2 hours ago</span>
															</div>
														</a>
														<a class="dropdown-item d-flex" href="notify-list.html">
															<div class="me-3 notifyimg  bg-success brround">
																<i class="fe fe-shopping-cart"></i>
															</div>
															<div class="mt-1 wd-80p">
																<h5 class="notification-label mb-1">Your Product Delivered
																</h5>
																<span class="notification-subtext">30 min ago</span>
															</div>
														</a>
														<a class="dropdown-item d-flex" href="notify-list.html">
															<div class="me-3 notifyimg bg-pink brround box-shadow-pink">
																<i class="fe fe-user-plus"></i>
															</div>
															<div class="mt-1 wd-80p">
																<h5 class="notification-label mb-1">Friend Requests</h5>
																<span class="notification-subtext">1 day ago</span>
															</div>
														</a>
													</div>
													<div class="dropdown-divider m-0"></div>
													<a href="notify-list.html"
														class="dropdown-item text-center p-3 text-muted">View all
														Notification</a>
												</div>
											</div>-->
											<!-- NOTIFICATIONS -->
											<!--<div class="dropdown  d-flex message">
												<a class="nav-link icon text-center" data-bs-toggle="dropdown">
													<i class="fe fe-message-square"></i><span class="pulse-danger"></span>
												</a>
												<div class="dropdown-menu dropdown-menu-end dropdown-menu-arrow">
													<div class="drop-heading border-bottom">
														<div class="d-flex">
															<h6 class="mt-1 mb-0 fs-16 fw-semibold text-dark">You have 5
																Messages</h6>
															<div class="ms-auto">
																<a href="javascript:void(0)" class="text-muted p-0 fs-12">make all unread</a>
															</div>
														</div>
													</div>
													<div class="message-menu message-menu-scroll">
														<a class="dropdown-item d-flex" href="chat.html">
															<span
																class="avatar avatar-md brround me-3 align-self-center cover-image"
																data-bs-image-src="<?php echo base_url(); ?>/admincss/images/users/1.jpg"></span>
															<div class="wd-90p">
																<div class="d-flex">
																	<h5 class="mb-1">Peter Theil</h5>
																	<small class="text-muted ms-auto text-end">
																		6:45 am
																	</small>
																</div>
																<span>Commented on file Guest list....</span>
															</div>
														</a>
														<a class="dropdown-item d-flex" href="chat.html">
															<span
																class="avatar avatar-md brround me-3 align-self-center cover-image"
																data-bs-image-src="<?php echo base_url(); ?>/admincss/images/users/15.jpg"></span>
															<div class="wd-90p">
																<div class="d-flex">
																	<h5 class="mb-1">Abagael Luth</h5>
																	<small class="text-muted ms-auto text-end">
																		10:35 am
																	</small>
																</div>
																<span>New Meetup Started......</span>
															</div>
														</a>
														<a class="dropdown-item d-flex" href="chat.html">
															<span
																class="avatar avatar-md brround me-3 align-self-center cover-image"
																data-bs-image-src="<?php echo base_url(); ?>/admincss/images/users/12.jpg"></span>
															<div class="wd-90p">
																<div class="d-flex">
																	<h5 class="mb-1">Brizid Dawson</h5>
																	<small class="text-muted ms-auto text-end">
																		2:17 pm
																	</small>
																</div>
																<span>Brizid is in the Warehouse...</span>
															</div>
														</a>
														<a class="dropdown-item d-flex" href="chat.html">
															<span
																class="avatar avatar-md brround me-3 align-self-center cover-image"
																data-bs-image-src="<?php echo base_url(); ?>/admincss/images/users/4.jpg"></span>
															<div class="wd-90p">
																<div class="d-flex">
																	<h5 class="mb-1">Shannon Shaw</h5>
																	<small class="text-muted ms-auto text-end">
																		7:55 pm
																	</small>
																</div>
																<span>New Product Realease......</span>
															</div>
														</a>
														<a class="dropdown-item d-flex" href="chat.html">
															<span
																class="avatar avatar-md brround me-3 align-self-center cover-image"
																data-bs-image-src="<?php echo base_url(); ?>/admincss/images/users/3.jpg"></span>
															<div class="wd-90p">
																<div class="d-flex">
																	<h5 class="mb-1">Cherry Blossom</h5>
																	<small class="text-muted ms-auto text-end">
																		7:55 pm
																	</small>
																</div>
																<span>You have appointment on......</span>
															</div>
														</a>

													</div>
													<div class="dropdown-divider m-0"></div>
													<a href="javascript:void(0)" class="dropdown-item text-center p-3 text-muted">See all
														Messages</a>
												</div>
											</div>-->
											<!-- MESSAGE-BOX -->
											<!--<div class="dropdown d-flex header-settings">
												<a href="javascript:void(0);" class="nav-link icon"
													data-bs-toggle="sidebar-right" data-target=".sidebar-right">
													<i class="fe fe-align-right"></i>
												</a>
											</div>-->
											<!-- SIDE-MENU -->
											<div class="dropdown d-flex profile-1">
												<a href="javascript:void(0)" data-bs-toggle="dropdown" class="nav-link leading-none d-flex">
													<img src="<?php echo base_url(); ?>/admincss/images/users/11.jpg" alt="profile-user"
														class="avatar  profile-user brround cover-image">
												</a>
												<div class="dropdown-menu dropdown-menu-end dropdown-menu-arrow">
													<div class="drop-heading">
														<div class="text-center">
															<h5 class="text-dark mb-0 fs-14 fw-semibold"><?php echo ucfirst($this->session->userdata('user_name'));?></h5>
															<small class="text-muted"><?php echo $this->session->userdata('user_group_name');  ?></small>
														</div>
													</div>
													<div class="dropdown-divider m-0"></div>
													<a class="dropdown-item" href="<?php echo site_url('my_account');?>">
														<i class="dropdown-icon fe fe-user"></i> My Account
													</a>
													<a class="dropdown-item" href="<?php echo site_url('Logout');?>">
														<i class="dropdown-icon fe fe-alert-circle"></i> Sign out
													</a>
												</div>
											</div>
										</div>
									<!-- </div> -->
								</div>
							</div>
						</div>
					</div>
				</div>
				<!-- /APP-HEADER -->
				<?php
						$this->load->view('templates/menu');
					?>
